var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import { keyframes } from '@emotion/core';
import styled from '../../../';
var largeIcons = {
    error: require('./icons/warning-filled.svg'),
    warning: require('./icons/warning.svg'),
    info: require('./icons/info-black.svg'),
    success: require('./icons/success.svg'),
};
var smallIcons = {
    error: require('./icons/warning-red.svg'),
    warning: require('./icons/warning.svg'),
    info: require('./icons/info-black.svg'),
    success: require('./icons/success-black.svg'),
};
var AlertContainer = styled.div(function (_a) {
    var type = _a.type, alertSize = _a.alertSize, fadeIn = _a.fadeIn, wide = _a.wide, theme = _a.theme;
    return (__assign(__assign(__assign({ backgroundRepeat: 'no-repeat', display: 'inline-block', textAlign: 'left', boxSizing: 'border-box', width: '100%', borderRadius: theme.borderRadius.small, maxWidth: wide ? undefined : 500 }, getStyle(type, alertSize, theme)), getAnimation(fadeIn)), { '> a': {
            color: 'inherit',
        } }));
});
var Heading = styled.div({
    fontWeight: 700,
});
var getStyle = function (type, alertSize, theme) {
    var backgroundColors = {
        error: theme.colors.red,
        warning: theme.colors.yellow,
        info: theme.colors.offWhite,
        success: theme.colors.green,
    };
    var textColors = {
        error: theme.colors.white,
        warning: theme.colors.black,
        info: theme.colors.black,
        success: theme.colors.white,
    };
    switch (alertSize) {
        case 'small':
            return {
                backgroundPosition: '0 4px',
                backgroundImage: "url(" + smallIcons[type] + ")",
                backgroundColor: 'transparent',
                color: type === 'error' ? theme.colors.red : undefined,
                fontWeight: 400,
                backgroundSize: '16px 16px',
                padding: 0,
                paddingLeft: 24,
                marginBottom: 0,
            };
        case 'large':
        default:
            return {
                backgroundPosition: '12px 12px',
                backgroundImage: "url(" + largeIcons[type] + ")",
                backgroundColor: backgroundColors[type],
                color: textColors[type],
                fontWeight: 500,
                backgroundSize: '24px 24px',
                padding: 10,
                paddingLeft: 48,
                marginBottom: '1.25em',
            };
    }
};
var getAnimation = function (fadeIn) {
    var fadeInFrames = keyframes({
        '0%': { opacity: 0 },
        '10%': { opacity: 1 },
        '90%': { opacity: 1 },
        '100%': { opacity: 0 },
    });
    return fadeIn ? { animation: fadeInFrames + " 3000ms forwards ease-in-out" } : {};
};
export var Alert = function (_a) {
    var heading = _a.heading, message = _a.message, _b = _a.alertSize, alertSize = _b === void 0 ? 'large' : _b, type = _a.type, fadeIn = _a.fadeIn, wide = _a.wide, rest = __rest(_a, ["heading", "message", "alertSize", "type", "fadeIn", "wide"]);
    return (React.createElement(AlertContainer, __assign({ role: "alert", alertSize: alertSize, type: type, fadeIn: fadeIn, wide: wide }, rest),
        heading && React.createElement(Heading, null, heading),
        typeof message === 'string' && React.createElement("span", { dangerouslySetInnerHTML: { __html: message } }),
        typeof message !== 'string' && message));
};
Alert.displayName = 'Collector.Alert';
//# sourceMappingURL=index.js.map