import React from 'react';
import { storiesOf } from '@storybook/react';
import { withKnobs, text, select, boolean } from '@storybook/addon-knobs';
import { Alert } from './';
import notes from './README.md';
var components = storiesOf('Components', module);
components.addDecorator(withKnobs);
components.add('Alert', function () {
    var sizes = ['small', 'large'];
    var types = ['error', 'warning', 'info', 'success'];
    return (React.createElement(Alert, { type: select('Type', types, 'error'), heading: text('Heading', ''), message: boolean('Use list instead of message', false) ? (React.createElement(React.Fragment, null,
            React.createElement("ul", { style: { margin: 0, paddingLeft: 16 } },
                React.createElement("li", null, "Message 1"),
                React.createElement("li", null, "Message 2")))) : (text('Message', 'Ett felmeddelande')), alertSize: select('Size', sizes, 'large'), wide: boolean('Wide', false) }));
}, { notes: notes });
//# sourceMappingURL=story.js.map