var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import * as React from 'react';
import { createFormattedNumberInput } from 'react-formatted-number-input';
import { formatMoney } from '../../../formatters';
import { Slider } from '../Slider';
import styled from '../../../';
var Minus = function () { return (React.createElement("svg", { width: "16", height: "2", xmlns: "http://www.w3.org/2000/svg" },
    React.createElement("path", { fill: "currentColor", d: "M1 2h14a1 1 0 0 0 0-2H1a1 1 0 1 0 0 2z" }))); };
var Plus = function () { return (React.createElement("svg", { width: "16", height: "16", xmlns: "http://www.w3.org/2000/svg" },
    React.createElement("path", { fill: "currentColor", d: "M9 7h6a1 1 0 0 1 0 2H9v6a1 1 0 0 1-2 0V9H1a1 1 0 1 1 0-2h6V1a1 1 0 1 1 2 0v6z" }))); };
var Container = styled.div({
    marginBottom: '3em',
});
var InputContainer = styled.div(function (_a) {
    var theme = _a.theme;
    return ({
        border: "1px solid " + theme.colors.mediumGray,
        borderRadius: theme.borderRadius.small,
        display: 'flex',
        height: 70,
        position: 'relative',
        zIndex: 2,
        marginBottom: '1em',
    });
});
var Input = styled.input(function (_a) {
    var _b;
    var theme = _a.theme;
    return (_b = {
            appearance: 'none',
            boxShadow: 'none',
            border: "solid " + theme.colors.mediumGray,
            borderWidth: '0 1px',
            borderRadius: 0,
            textAlign: 'center',
            width: '100%',
            flex: '80% 1 1',
            font: theme.fonts.desktop.xl
        },
        _b[theme.breakpoints.mobileAndLower] = {
            font: theme.fonts.mobile.xl,
        },
        _b['::-ms-clear'] = {
            display: 'none',
        },
        _b);
});
var AmountInput = createFormattedNumberInput(Input);
var Button = styled.button(function (_a) {
    var theme = _a.theme;
    return ({
        fontFamily: 'inherit',
        background: 'transparent',
        border: 0,
        display: 'flex',
        justifyContent: 'center',
        alignItems: 'center',
        flexShrink: 0,
        width: 55,
        fontSize: 40,
        padding: 0,
        cursor: 'pointer',
        borderRadius: theme.borderRadius.small,
        transition: 'background-color 100ms',
        color: theme.colors.black,
        ':hover': {
            background: theme.colors.offWhite,
        },
    });
});
var Range = styled.div(function (_a) {
    var _b;
    var theme = _a.theme;
    return (_b = {
            display: 'flex',
            justifyContent: 'space-between',
            font: theme.fonts.desktop.medium
        },
        _b[theme.breakpoints.mobileAndLower] = {
            font: theme.fonts.mobile.medium,
        },
        _b);
});
var AmountSelector = /** @class */ (function (_super) {
    __extends(AmountSelector, _super);
    function AmountSelector() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            isDrafting: false,
        };
        _this.increase = function () {
            var remainder = _this.props.value % _this.props.stepSize;
            var value = remainder > 0 ? _this.props.value + _this.props.stepSize - remainder : _this.props.value + _this.props.stepSize;
            _this.props.onChange(Math.min(value, _this.props.max));
        };
        _this.decrease = function () {
            var remainder = _this.props.value % _this.props.stepSize;
            var value = remainder > 0 ? _this.props.value - remainder : _this.props.value - _this.props.stepSize;
            _this.props.onChange(Math.max(value, _this.props.min));
        };
        _this.handleRangeInputChange = function (event) {
            var middle = _this.props.max - _this.props.min;
            var value = Number(event.currentTarget.value);
            if (value > middle) {
                value = Math.ceil(value / _this.props.stepSize) * _this.props.stepSize;
                value = Math.min(value, _this.props.max);
            }
            else {
                value = Math.floor(value / _this.props.stepSize) * _this.props.stepSize;
                value = Math.max(value, _this.props.min);
            }
            _this.props.onChange(value);
        };
        _this.changeDraftValue = function (draftValue) {
            _this.setState({
                isDrafting: true,
                draftValue: draftValue,
            });
        };
        _this.commitDraftValue = function () {
            if (_this.state.isDrafting && _this.state.draftValue != null) {
                var normalized = _this.clampAndRound(_this.state.draftValue);
                _this.props.onChange(normalized);
                _this.setState({
                    isDrafting: false,
                    draftValue: undefined,
                });
            }
        };
        _this.clampAndRound = function (value) {
            if (value <= _this.props.min) {
                return _this.props.min;
            }
            else if (value >= _this.props.max) {
                return _this.props.max;
            }
            else {
                return Math.round(value / _this.props.stepSize) * _this.props.stepSize;
            }
        };
        return _this;
    }
    AmountSelector.prototype.render = function () {
        var _a = this.props, min = _a.min, max = _a.max, value = _a.value, currency = _a.currency;
        var _b = this.state, isDrafting = _b.isDrafting, draftValue = _b.draftValue;
        return (React.createElement(Container, null,
            React.createElement(InputContainer, null,
                React.createElement(Button, { onClick: this.decrease, "data-testid": "decrease" },
                    React.createElement(Minus, null)),
                React.createElement(AmountInput, { value: isDrafting ? draftValue : value, onChange: this.changeDraftValue, onBlur: this.commitDraftValue, pattern: "[0-9]*", "data-testid": "input" }),
                React.createElement(Button, { onClick: this.increase, "data-testid": "increase" },
                    React.createElement(Plus, null))),
            React.createElement(Slider, { type: "range", min: min, max: max, value: value, onChange: this.handleRangeInputChange, "data-testid": "slider" }),
            React.createElement(Range, null,
                React.createElement("div", null, formatMoney(min, currency, false)),
                React.createElement("div", null, formatMoney(max, currency, false)))));
    };
    AmountSelector.displayName = 'Collector.AmountSelector';
    return AmountSelector;
}(React.Component));
export { AmountSelector };
//# sourceMappingURL=index.js.map