import React from 'react';
import { storiesOf } from '@storybook/react';
import { withKnobs, text, number } from '@storybook/addon-knobs';
import { State, Store } from '@sambego/storybook-state';
import { AmountSelector } from './';
import notes from './README.md';
var components = storiesOf('Components', module);
components.addDecorator(withKnobs);
var store = new Store({
    value: 1000,
});
components.add('Amount selector', function () {
    return (React.createElement("div", { style: { maxWidth: 500 } },
        React.createElement(State, { store: store },
            React.createElement(AmountSelector, { currency: text('Currency', 'SEK'), min: number('Min', 940), max: number('Max', 2038), value: store.get('value'), onChange: function (value) { return store.set({ value: value }); }, stepSize: number('Step size', 100) }))));
}, { notes: notes });
//# sourceMappingURL=story.js.map