var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import { Tooltip } from '../Tooltip';
import styled from '../../../';
var Container = styled.div(function (_a) {
    var _b;
    var theme = _a.theme;
    return (_b = {
            display: 'inline-block',
            font: theme.fonts.desktop.small,
            fontWeight: 500,
            marginLeft: '1em',
            marginRight: '1em',
            position: 'relative'
        },
        _b[theme.breakpoints.mobileAndLower] = {
            position: 'static',
        },
        _b);
});
var Label = styled.span(function (_a) {
    var color = _a.color, theme = _a.theme;
    return ({
        padding: '4px 12px',
        whiteSpace: 'nowrap',
        position: 'relative',
        borderRadius: theme.borderRadius.large,
        background: theme.colors[color],
        color: color === 'yellow' || color === 'lightGray' ? theme.colors.darkIndigo : theme.colors.white,
    });
});
var Badge = /** @class */ (function (_super) {
    __extends(Badge, _super);
    function Badge() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            tooltipIsVisible: false,
        };
        _this.showTooltip = function () {
            _this.setState({ tooltipIsVisible: true });
        };
        _this.hideTooltip = function () {
            _this.setState({ tooltipIsVisible: false });
        };
        _this.toggleTooltip = function () {
            _this.setState(function (prevState) { return ({ tooltipIsVisible: !prevState.tooltipIsVisible }); });
        };
        return _this;
    }
    Badge.prototype.render = function () {
        var _a = this.props, label = _a.label, tooltip = _a.tooltip, _b = _a.color, color = _b === void 0 ? 'purple' : _b, rest = __rest(_a, ["label", "tooltip", "color"]);
        return (React.createElement(Container, __assign({}, rest),
            React.createElement(Label, { color: color, onMouseEnter: tooltip ? this.showTooltip : undefined, onMouseLeave: tooltip ? this.hideTooltip : undefined, onClick: tooltip ? this.toggleTooltip : undefined }, label),
            tooltip && React.createElement(Tooltip, { visible: this.state.tooltipIsVisible }, tooltip)));
    };
    Badge.displayName = 'Collector.Badge';
    return Badge;
}(React.Component));
export { Badge };
//# sourceMappingURL=index.js.map