import React from 'react';
import { Theme } from '../../../themes';
export declare type ButtonKind = 'primary' | 'secondary' | 'secondaryNegative' | 'success' | 'warn' | 'text' | 'cta';
export declare type ButtonSize = 'small' | 'medium' | 'large';
export declare type IconAlignment = 'start' | 'end';
export interface ButtonProps {
    name?: string;
    value?: string;
    size?: ButtonSize;
    icon?: JSX.Element;
    kind?: ButtonKind;
    iconAlignment?: IconAlignment;
    onClick?: () => void;
    disabled?: boolean;
    loading?: boolean;
}
export declare const Button: React.SFC<import("emotion-theming/types/helper").AddOptionalTo<ButtonProps & React.HTMLAttributes<HTMLButtonElement> & {
    theme: Theme;
} & React.RefAttributes<HTMLButtonElement>, "theme">>;
