var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import { Link as RouterLink } from 'react-router-dom';
import styled from '../../../';
import { Badge } from '..';
var cross = "'data:image/svg+xml,%3Csvg xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/1999/xlink\" width=\"14\" height=\"14\"%3E%3Cdefs%3E%3Cpath id=\"a\" d=\"M13.4142136 12l5.2928932 5.2928932c.3905243.3905243.3905243 1.0236893 0 1.4142136-.3905243.3905243-1.0236893.3905243-1.4142136 0L12 13.4142136l-5.29289322 5.2928932c-.39052429.3905243-1.02368927.3905243-1.41421356 0-.39052429-.3905243-.39052429-1.0236893 0-1.4142136L10.5857864 12 5.29289322 6.70710678c-.39052429-.39052429-.39052429-1.02368927 0-1.41421356.39052429-.39052429 1.02368927-.39052429 1.41421356 0L12 10.5857864l5.2928932-5.29289318c.3905243-.39052429 1.0236893-.39052429 1.4142136 0 .3905243.39052429.3905243 1.02368927 0 1.41421356L13.4142136 12z\"/%3E%3C/defs%3E%3Cg fill=\"none\" fill-rule=\"evenodd\" transform=\"translate(-5 -5)\"%3E%3Cmask id=\"b\" fill=\"%23fff\"%3E%3Cuse xlink:href=\"%23a\"/%3E%3C/mask%3E%3Cuse fill=\"%23000\" fill-rule=\"nonzero\" xlink:href=\"%23a\"/%3E%3Cg fill=\"%23000\" mask=\"url(%23b)\"%3E%3Cpath d=\"M0 0h24v24H0z\"/%3E%3C/g%3E%3C/g%3E%3C/svg%3E'";
var BodyContainer = styled.div(function (_a) {
    var theme = _a.theme, backgroundColor = _a.backgroundColor;
    return ({
        position: 'relative',
        display: 'block',
        boxShadow: 'rgba(17,6,19, 0.3) 0px 1px 3px 0px, rgba(17,6,19, 0.12) 0px 15px 25px -10px',
        boxSizing: 'border-box',
        width: 290,
        padding: 24,
        paddingTop: 32,
        marginBottom: 24,
        color: backgroundColor !== 'darkPurple' ? theme.colors.black : theme.colors.white,
        textDecoration: 'none',
        minHeight: 200,
        borderRadius: theme.borderRadius.large,
        background: theme.colors[backgroundColor ? backgroundColor : 'white'],
    });
});
var Body = styled.div({
    overflowWrap: 'break-word',
});
var SubBody = styled.div(function (_a) {
    var theme = _a.theme;
    return ({
        borderColor: theme.colors.lightGray,
    });
});
var Dismissable = styled.div({
    width: 14,
    height: 14,
    backgroundImage: "url(" + cross + ")",
    position: 'absolute',
    right: 16,
    top: 16,
    '&:hover': {
        cursor: 'pointer',
    },
});
var Link = styled(RouterLink)(function (_a) {
    var theme = _a.theme;
    return ({
        display: 'inherit',
        color: 'inherit',
        textDecoration: 'none',
        position: 'relative',
        '&:hover::after': {
            opacity: 1,
        },
        '&:focus': {
            outline: 'none',
            '> div > div': {
                outline: '-webkit-focus-ring-color auto 5px',
            },
        },
    });
});
var HeadingContainer = styled.div({
    display: 'flex',
    justifyContent: 'space-between',
});
var BadgeContainer = styled.div({
    position: 'absolute',
    top: 0,
    left: 0,
    zIndex: 2,
    transform: 'translate(-1px, -50%)',
});
var CardContainer = styled.div({
    position: 'relative',
});
export var Card = function (_a) {
    var heading = _a.heading, badgeColor = _a.badgeColor, body = _a.body, subBody = _a.subBody, onDismiss = _a.onDismiss, location = _a.location, rest = __rest(_a, ["heading", "badgeColor", "body", "subBody", "onDismiss", "location"]);
    var card = (React.createElement(CardContainer, null,
        heading && (React.createElement(HeadingContainer, null,
            React.createElement(BadgeContainer, null,
                React.createElement(Badge, { color: badgeColor, label: heading })))),
        React.createElement(BodyContainer, __assign({}, rest),
            onDismiss && React.createElement(Dismissable, { onClick: onDismiss }),
            React.createElement(Body, null, body),
            subBody && React.createElement(SubBody, null, subBody))));
    if (location) {
        return React.createElement(Link, { to: location }, card);
    }
    else {
        return card;
    }
};
//# sourceMappingURL=index.js.map