import React from 'react';
import { storiesOf } from '@storybook/react';
import { withKnobs, text, boolean, select } from '@storybook/addon-knobs';
import { Card } from './';
import { Button, H3, Text } from '../../../components';
import { CardGroup } from './CardGroup';
import notes from './README.md';
import { BrowserRouter } from 'react-router-dom';
var components = storiesOf('Components', module);
components.addDecorator(withKnobs);
components.add('Card', function () {
    return (React.createElement("div", { style: { padding: 24 } },
        React.createElement(Card, { body: React.createElement("div", { style: { minHeight: 110 } },
                React.createElement(H3, null, text('Title', 'My title')),
                React.createElement(Text, null, text('Body', 'Här kommer det in mer text'))), subBody: React.createElement(React.Fragment, null,
                React.createElement("div", { style: { display: 'flex', justifyContent: 'center', flexDirection: 'column' } },
                    React.createElement(Button, { kind: "cta", onClick: function () { return null; } }, "Button"))), badgeColor: "yellow", backgroundColor: select('Background color', ['white', 'darkPurple'], 'white'), heading: text('Heading', 'Card 1 heading'), onDismiss: boolean('Dismissable', false) ? function () { return console.log('Card dismissal event'); } : undefined }),
        boolean('Show cardgroup', true) && (React.createElement(CardGroup, { style: { paddingBottom: 14 } },
            React.createElement(Card, { body: React.createElement("div", { style: { minHeight: 110 } },
                    React.createElement(H3, null, text('Title', 'My title')),
                    React.createElement(Text, null, text('Body', 'Här kommer det in mer text'))), subBody: React.createElement(React.Fragment, null,
                    React.createElement("div", { style: { display: 'flex', justifyContent: 'center', flexDirection: 'column' } },
                        React.createElement(Button, { onClick: function () { return null; } }, "Button"))), badgeColor: "pink", backgroundColor: select('Background color', ['white', 'darkPurple'], 'white'), heading: "Label 2" }),
            React.createElement(BrowserRouter, null,
                React.createElement(Card, { body: React.createElement("div", { style: { minHeight: 120 } },
                        React.createElement(H3, null, text('Title', 'My title')),
                        React.createElement(Text, null,
                            React.createElement("span", null, "Det h\u00E4r \u00E4r en l\u00E4nk knapp."),
                            React.createElement("br", null),
                            React.createElement("br", null),
                            React.createElement("span", null, "Trycker man p\u00E5 det h\u00E4r hamnar man dock ingenstans"))), location: "/#", badgeColor: "red", backgroundColor: select('Background color', ['white', 'darkPurple'], 'white'), heading: "Label 3" }))))));
}, { notes: notes });
//# sourceMappingURL=story.js.map