var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import Collapse from 'react-css-collapse';
import { ClassNames } from '@emotion/core';
import uniqid from 'uniqid';
import { Checkbox } from './';
import { Alert } from '../Alert';
import { Label } from '../Label';
import styled from '../../../';
var CheckboxGroupContainer = styled.div({
    marginBottom: '1.25em',
});
var CheckboxList = styled.ul({
    listStyleType: 'none',
    padding: 0,
    margin: 0,
});
var KidsContainer = styled.div({
    overflow: 'hidden',
    marginLeft: 34,
    maxWidth: 500 - 34,
});
var CheckboxGroup = /** @class */ (function (_super) {
    __extends(CheckboxGroup, _super);
    function CheckboxGroup() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            name: uniqid(),
        };
        _this.handleChange = function (key, event) {
            _this.props.onChange(key, event.currentTarget.checked);
        };
        _this.isChecked = function (optionId) {
            if (_this.props.checked) {
                return _this.props.checked.some(function (x) { return x === optionId; });
            }
            else {
                return false;
            }
        };
        return _this;
    }
    CheckboxGroup.prototype.render = function () {
        var _this = this;
        var _a = this.props, label = _a.label, items = _a.items, disabled = _a.disabled, error = _a.error, rest = __rest(_a, ["label", "items", "disabled", "error"]);
        return (React.createElement(ClassNames, __assign({}, rest), function (_a) {
            var css = _a.css;
            return (React.createElement(CheckboxGroupContainer, null,
                React.createElement(Label, null, label),
                React.createElement(CheckboxList, null, items.map(function (item) { return (React.createElement("li", { key: item.key },
                    React.createElement(Checkbox, { label: item.label, name: _this.state.name, checked: _this.isChecked(item.key), disabled: disabled, onChange: function (event) { return _this.handleChange(item.key, event); } }),
                    React.createElement(Collapse, { isOpen: _this.isChecked(item.key), className: css({ transition: 'height 150ms' }) },
                        React.createElement(KidsContainer, null, item.child)))); })),
                error && typeof error === 'string' && React.createElement(Alert, { type: "error", message: error, alertSize: "small" })));
        }));
    };
    CheckboxGroup.displayName = 'Collector.CheckboxGroup';
    return CheckboxGroup;
}(React.Component));
export { CheckboxGroup };
//# sourceMappingURL=CheckboxGroup.js.map