var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import uniqid from 'uniqid';
import styled from '../../../';
var checkboxSvg = "'data:image/svg+xml,%3Csvg xmlns=%22http://www.w3.org/2000/svg%22 viewBox=%220 0 9.862 8.198%22%3E%3Cpath fill=%22%23fff%22 d=%22M8.972.188l-5.364 6.72L.883 3.659a.5.5 0 1 0-.766.642l3.117 3.718a.502.502 0 0 0 .383.179h.006a.502.502 0 0 0 .385-.188L9.753.812A.498.498 0 0 0 9.674.11a.498.498 0 0 0-.702.078z%22/%3E%3C/svg%3E%0A'";
var CheckboxContainer = styled.div(function (_a) {
    var disabled = _a.disabled;
    return ({
        display: 'flex',
        marginBottom: 8,
        opacity: disabled ? 0.5 : 1,
    });
});
var Input = styled.input(function (_a) {
    var theme = _a.theme;
    return ({
        appearance: 'none',
        position: 'relative',
        background: 'none',
        border: '1px solid currentColor',
        width: 20,
        height: 20,
        flexShrink: 0,
        marginRight: '1em',
        transition: 'border-color 150ms, background 150ms, opacity 150ms',
        borderRadius: theme.borderRadius.small,
        '&:after': {
            content: '""',
            position: 'absolute',
            top: 0,
            bottom: 0,
            left: 0,
            right: 0,
            backgroundRepeat: 'no-repeat',
            backgroundPosition: '50%',
            backgroundSize: '75%',
            transition: 'background 150ms',
        },
        '&:checked:after': {
            backgroundImage: "url(" + checkboxSvg + ")",
        },
        '&:checked': {
            backgroundColor: theme.colors.purple,
            borderColor: theme.colors.purple,
        },
        '&:disabled': {
            opacity: 0.6,
            borderColor: theme.colors.darkGray,
        },
    });
});
var Checkbox = /** @class */ (function (_super) {
    __extends(Checkbox, _super);
    function Checkbox() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            id: uniqid(),
        };
        return _this;
    }
    Checkbox.prototype.render = function () {
        var _a = this.props, label = _a.label, name = _a.name, checked = _a.checked, disabled = _a.disabled, onChange = _a.onChange, rest = __rest(_a, ["label", "name", "checked", "disabled", "onChange"]);
        return (React.createElement(CheckboxContainer, __assign({ disabled: disabled }, rest),
            React.createElement(Input, { type: "checkbox", id: this.state.id, name: name, checked: checked, disabled: disabled, onChange: onChange }),
            React.createElement("label", { htmlFor: this.state.id, dangerouslySetInnerHTML: { __html: label } })));
    };
    Checkbox.displayName = 'Collector.Checkbox';
    return Checkbox;
}(React.Component));
export { Checkbox };
//# sourceMappingURL=index.js.map