var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
import React from 'react';
import { storiesOf } from '@storybook/react';
import { withKnobs, text, boolean } from '@storybook/addon-knobs';
import { State, Store } from '@sambego/storybook-state';
import { Checkbox } from './';
import { CheckboxGroup } from './CheckboxGroup';
import notes from './README.md';
import groupReadme from './GroupREADME.md';
var components = storiesOf('Components', module);
components.addDecorator(withKnobs);
var store = new Store({
    checked: false,
});
components.add('Checkbox', function () {
    return (React.createElement(State, { store: store },
        React.createElement(Checkbox, { label: text('Label', 'En label'), disabled: boolean('Disabled', false), checked: store.get('checked'), onChange: function () { return store.set({ checked: !store.get('checked') }); } })));
}, { notes: notes });
var groupStore = new Store({
    checked: ['foo', 'baz'],
});
components.add('Checkbox group', function () {
    var items = [
        {
            key: 'foo',
            label: 'Alternativ 1',
        },
        {
            key: 'bar',
            label: 'Alternativ 2',
        },
        {
            key: 'baz',
            label: 'Alternativ 3',
            child: React.createElement("div", null, "H\u00E4r \u00E4r ett barn-element, som bara syns om \"Alternativ 3\" \u00E4r markerat"),
        },
    ];
    return (React.createElement(State, { store: groupStore },
        React.createElement(CheckboxGroup, { label: text('Label', 'En label'), items: items, disabled: boolean('Disabled', false), error: text('Error', ''), checked: groupStore.get('checked'), onChange: function (optionId, selected) {
                groupStore.set({
                    checked: selected
                        ? __spreadArrays(groupStore.get('checked'), [optionId]) : groupStore.get('checked').filter(function (x) { return x !== optionId; }),
                });
            } })));
}, { notes: groupReadme });
//# sourceMappingURL=story.js.map