var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import ReactDatePicker, { registerLocale, setDefaultLocale } from 'react-datepicker';
import Collapse from 'react-css-collapse';
import { css } from 'glamor';
import { Label, InputError } from '../';
import { InputContainer, InputField } from '../Input';
import styled from '../../../';
import sv from 'date-fns/locale/sv';
import nb from 'date-fns/locale/nb';
import fi from 'date-fns/locale/fi';
import 'react-datepicker/dist/react-datepicker.css';
import { withTheme } from 'emotion-theming';
registerLocale('sv', sv);
registerLocale('nb', nb);
registerLocale('fi', fi);
setDefaultLocale('sv');
var calendar = "'data:image/svg+xml,%3Csvg xmlns=%22http://www.w3.org/2000/svg%22 viewBox=%220 0 16 16%22%3E%3Cpath fill=%22%23111%22 d=%22M13.504 1.463h-1.223V.502a.5.5 0 0 0-1 0v.961H4.742V.502a.5.5 0 0 0-1 0v.961H2.52c-.758 0-1.374.616-1.374 1.374v11.339a.5.5 0 0 0 .5.5h12.732a.5.5 0 0 0 .5-.5V2.837c0-.758-.616-1.374-1.374-1.374zm-10.984 1h10.984c.206 0 .374.168.374.374v1.857H2.146V2.837c0-.206.168-.374.374-.374zm-.374 11.213V5.694h11.732v7.982H2.146z%22/%3E%3Cpath fill=%22%23111%22 d=%22M12.117 8.904h-2.5a.5.5 0 0 0-.5.5v2.5a.5.5 0 0 0 .5.5h2.5a.5.5 0 0 0 .5-.5v-2.5a.5.5 0 0 0-.5-.5zm-.5 2.5h-1.5v-1.5h1.5v1.5z%22/%3E%3C/svg%3E'";
var inputErrorTransition = css({
    transition: 'height 150ms',
});
var InputFieldWithIcon = styled(InputField)({
    background: "url(" + calendar + ") no-repeat 95% center",
    backgroundPosition: "calc(100% - 12px) 50%",
    backgroundSize: '24px 24px',
});
var style = function (theme) {
    return css({
        '.react-datepicker': {
            font: theme.fonts.desktop.small,
            borderColor: theme.colors.mediumGray,
            borderRadius: theme.borderRadius.small,
            '& .react-datepicker__current-month, & .react-datepicker__day-name': {
                textTransform: 'capitalize',
            },
            '& .react-datepicker__current-month': {
                font: theme.fonts.desktop.medium,
                fontWeight: 500,
            },
            '& .react-datepicker__navigation': {
                top: 14,
            },
            '& .react-datepicker__day-name, & .react-datepicker__day': {
                width: 32,
                lineHeight: '32px',
            },
            '& .react-datepicker__day--selected': {
                backgroundColor: theme.colors.purple,
            },
            '& .react-datepicker__day:not(.react-datepicker__day--selected):not(.react-datepicker__day--disabled):hover': {
                backgroundColor: theme.colors.offWhite,
            },
            '& .react-datepicker__day-name': {
                color: theme.colors.darkGray,
            },
            '& .react-datepicker__header': {
                backgroundColor: theme.colors.offWhite,
                borderColor: theme.colors.mediumGray,
                borderTopLeftRadius: theme.borderRadius.small,
                borderTopRightRadius: theme.borderRadius.small,
            },
            '.react-datepicker-popper[data-placement^="bottom"] & .react-datepicker__triangle': {
                borderBottomColor: theme.colors.offWhite,
            },
            '.react-datepicker-popper[data-placement^="bottom"] & .react-datepicker__triangle:before': {
                borderBottomColor: theme.colors.mediumGray,
            },
            '& .react-datepicker__navigation--previous': {
                borderRightColor: theme.colors.mediumGray,
            },
            '& .react-datepicker__navigation--next': {
                borderLeftColor: theme.colors.mediumGray,
            },
        },
    });
};
var inputWidth = 220;
css.global('.react-datepicker__input-container', {
    width: inputWidth,
});
var DatePicker_ = /** @class */ (function (_super) {
    __extends(DatePicker_, _super);
    function DatePicker_() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            showError: false,
            isValid: true,
        };
        /*
         * Here we use the fact that there are two onChange handlers, one of which
         * is used to set a valid date only, to handle an invalid state.
         * We set the isValid state to true whenever a valid date is set,
         * which is the onChange, but we always set isValid to false otherwise.
         * Since onChange is always executed later, we are able to ensure that
         * isValid is only set to valid if a proper onChange has been run.
         * Then, onBlur, if we did not recieve an onChange event, we display an error message.
         */
        _this.handleChange = function (date) {
            _this.setState({ isValid: true }, function () {
                _this.props.onChange(date);
            });
        };
        _this.handleChangeRaw = function () {
            _this.setState({ isValid: false });
        };
        _this.handleBlur = function () {
            _this.setState(function (prevState) { return ({ showError: !prevState.isValid }); }, function () {
                if (!_this.state.isValid) {
                    _this.props.onChange(null);
                }
            });
        };
        return _this;
    }
    DatePicker_.prototype.render = function () {
        var _a = this.props, label = _a.label, locale = _a.locale, selectedDate = _a.selectedDate, minDate = _a.minDate, maxDate = _a.maxDate, invalidMessage = _a.invalidMessage, onChange = _a.onChange, rest = __rest(_a, ["label", "locale", "selectedDate", "minDate", "maxDate", "invalidMessage", "onChange"]);
        var showError = Boolean(this.state.showError && !this.state.isValid && invalidMessage);
        var calendarClassName = "" + style(this.props.theme);
        return (React.createElement(InputContainer, __assign({}, rest),
            label && React.createElement(Label, null, label),
            React.createElement(ReactDatePicker, { locale: locale, selected: selectedDate, minDate: minDate, maxDate: maxDate, dateFormat: "yyyy-MM-dd", useWeekdaysShort: true, calendarClassName: calendarClassName, onChange: this.handleChange, onChangeRaw: this.handleChangeRaw, onBlur: this.handleBlur, customInput: React.createElement(InputFieldWithIcon, { hasError: showError }) }),
            React.createElement(Collapse, { isOpen: showError, className: "" + inputErrorTransition },
                React.createElement(InputError, { style: { maxWidth: inputWidth } }, invalidMessage))));
    };
    DatePicker_.displayName = 'Collector.DatePicker';
    return DatePicker_;
}(React.Component));
export var DatePicker = withTheme(DatePicker_);
//# sourceMappingURL=index.js.map