import React from 'react';
import { storiesOf } from '@storybook/react';
import { text, withKnobs } from '@storybook/addon-knobs';
import { State, Store } from '@sambego/storybook-state';
import { DatePicker } from './';
import notes from './README.md';
var components = storiesOf('Components', module);
components.addDecorator(withKnobs);
var store = new Store({
    selectedDate: new Date(),
});
components.add('Date picker', function () {
    return (React.createElement(State, { store: store },
        React.createElement(DatePicker, { locale: "sv", label: text('Label', 'En label'), invalidMessage: "Felaktigt datum!", minDate: new Date(), selectedDate: store.get('selectedDate'), onChange: function (selectedDate) { return store.set({ selectedDate: selectedDate }); } })));
}, { notes: notes });
//# sourceMappingURL=story.js.map