var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import React from 'react';
import { Tooltip } from '../Tooltip';
import { withTheme } from 'emotion-theming';
import styled from '../../../';
var Container = styled.div(function (_a) {
    var _b;
    var theme = _a.theme;
    return (_b = {
            display: 'inline-block',
            width: 20,
            height: 20,
            marginLeft: 4,
            position: 'relative'
        },
        _b[theme.breakpoints.mobileAndLower] = {
            position: 'static',
        },
        _b);
});
var Description_ = /** @class */ (function (_super) {
    __extends(Description_, _super);
    function Description_() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            tooltipIsVisible: false,
        };
        _this.showTooltip = function () {
            _this.setState({ tooltipIsVisible: true });
        };
        _this.hideTooltip = function () {
            _this.setState({ tooltipIsVisible: false });
        };
        _this.toggleTooltip = function (event) {
            event.preventDefault();
            _this.setState(function (prevState) { return ({ tooltipIsVisible: !prevState.tooltipIsVisible }); });
        };
        return _this;
    }
    Description_.prototype.render = function () {
        return (React.createElement(Container, { onMouseEnter: this.showTooltip, onMouseLeave: this.hideTooltip, onClick: this.toggleTooltip },
            React.createElement("svg", { fill: this.props.theme.colors.purple, viewBox: "0 0 24 24", xmlns: "http://www.w3.org/2000/svg" },
                React.createElement("path", { d: "M0 0h24v24H0z", fill: "none" }),
                React.createElement("path", { d: "M11 17h2v-6h-2v6zm1-15C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 18c-4.41 0-8-3.59-8-8s3.59-8 8-8 8 3.59 8 8-3.59 8-8 8zM11 9h2V7h-2v2z" })),
            React.createElement(Tooltip, { visible: this.state.tooltipIsVisible }, this.props.description)));
    };
    Description_.displayName = 'Collector.Description';
    return Description_;
}(React.Component));
export { Description_ };
export var Description = withTheme(Description_);
//# sourceMappingURL=Description.js.map