import { boolean, number, text, withKnobs } from '@storybook/addon-knobs';
import { State, Store } from '@sambego/storybook-state';
import { storiesOf } from '@storybook/react';
import React from 'react';
import { Input } from './';
import notes from './README.md';
var components = storiesOf('Components', module);
components.addDecorator(withKnobs);
var store = new Store({
    value: '',
});
components.add('Input', function () {
    return (React.createElement(State, { store: store },
        React.createElement(Input, { label: text('Label', 'En label'), placeholder: text('Placeholder', ''), error: text('Error', ''), warning: text('Warning', ''), description: text('Description', ''), multiline: boolean('Multiline', false), disabled: boolean('Disabled', false), rows: number('Rows', 10), value: store.get('value'), ref: function (ref) { return console.log(ref); }, onChange: function (event) { return store.set({ value: event.currentTarget.value }); }, togglePassword: boolean('togglePassword', false), togglePasswordWidth: number('togglePasswordWidth', 500) })));
}, { notes: notes });
//# sourceMappingURL=story.js.map