var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { useState } from 'react';
import styled from '../../..';
import { ArrowDown } from './ArrowDown';
import { ArrowRight } from './ArrowRight';
import { breakpoints } from '../../../themes/collector';
import { Link as RouterLink } from 'react-router-dom';
import Collapse from 'react-css-collapse';
import { ClassNames } from '@emotion/core';
var LinkItemContainer = styled.li(function (_a) {
    var theme = _a.theme;
    return ({
        borderBottom: "1px solid " + theme.colors.lightGray,
        width: '100%',
        listStyle: 'none',
    });
});
var Container = styled.div(function (_a) {
    var _b;
    var theme = _a.theme, others = _a.others;
    return (_b = {
            display: 'flex',
            padding: '21px 16px',
            textDecoration: 'none',
            color: 'initial',
            transition: 'background ease-in 100ms',
            '&:hover': {
                background: others.isClickable ? theme.colors.lightOffWhite : 'initial',
                cursor: others.isClickable ? 'pointer' : 'inherit',
            }
        },
        _b[theme.breakpoints.mobileAndLower] = {
            padding: '16px 8px',
        },
        _b);
});
var LinkContainer = Container.withComponent(RouterLink);
var TitleContainer = styled.div(function (_a) {
    var _b;
    var theme = _a.theme;
    return (_b = {
            font: theme.fonts.mobile.large,
            color: theme.colors.black
        },
        _b[breakpoints.mobileAndLower] = {
            font: theme.fonts.mobile.medium,
        },
        _b);
});
var DetailsContainer = styled.div(function (_a) {
    var _b;
    var theme = _a.theme;
    return (_b = {
            font: theme.fonts.mobile.large,
            color: theme.colors.black
        },
        _b[breakpoints.mobileAndLower] = {
            font: theme.fonts.mobile.medium,
            fontWeight: 600,
        },
        _b.fontWeight = 600,
        _b);
});
var SubTitleContainer = styled.div(function (_a) {
    var _b;
    var theme = _a.theme;
    return (_b = {
            color: theme.colors.darkGray
        },
        _b[theme.breakpoints.mobileAndLower] = {
            font: theme.fonts.mobile.small,
        },
        _b);
});
var SubDetailsContainer = styled.div(function (_a) {
    var _b;
    var theme = _a.theme;
    return (_b = {
            color: theme.colors.darkGray
        },
        _b[theme.breakpoints.mobileAndLower] = {
            font: theme.fonts.mobile.small,
        },
        _b);
});
var ExpandedContainer = styled.div(function (_a) {
    var _b;
    var theme = _a.theme;
    return (_b = {
            padding: '8px 16px'
        },
        _b[theme.breakpoints.mobileAndLower] = {
            padding: 8,
        },
        _b.paddingTop = 0,
        _b);
});
var LeftColumn = styled.div({ width: '100%', display: 'flex', flexDirection: 'column', justifyContent: 'center' });
var RightColumn = styled.div({
    width: '100%',
    display: 'flex',
    flexDirection: 'column',
    alignItems: 'flex-end',
    justifyContent: 'center',
    textAlign: 'right',
});
export var ListItem = function (_a) {
    var item = _a.item, location = _a.location, children = _a.children, onClick = _a.onClick, rest = __rest(_a, ["item", "location", "children", "onClick"]);
    var _b = useState(false), isExpanded = _b[0], setIsExpanded = _b[1];
    var _c = useState(false), isHovered = _c[0], setIsHovered = _c[1];
    if (location && children) {
        throw new Error('Listitem cannot be expandable and linkable at the same time');
    }
    if (location && onClick) {
        throw new Error('Listitem cannot be clickable and linkable at the same time');
    }
    var renderBody = function () { return (React.createElement(React.Fragment, null,
        (item.title || item.subTitle) && (React.createElement(LeftColumn, null,
            item.title && React.createElement(TitleContainer, null, item.title),
            item.subTitle && React.createElement(SubTitleContainer, null, item.subTitle))),
        (item.details || item.subDetails) && (React.createElement(RightColumn, null,
            item.details && React.createElement(DetailsContainer, null, item.details),
            item.subDetails && React.createElement(SubDetailsContainer, null, item.subDetails))),
        children && React.createElement(ArrowDown, { isHovered: isHovered, isExpanded: isExpanded }),
        (location || onClick) && React.createElement(ArrowRight, { isHovered: isHovered }))); };
    return (React.createElement(LinkItemContainer, __assign({ onMouseEnter: function () { return setIsHovered(true); }, onMouseLeave: function () { return setIsHovered(false); } }, rest),
        onClick && (React.createElement(Container, { onClick: onClick, others: { isClickable: true } }, renderBody())),
        location && (React.createElement(LinkContainer, { others: { isClickable: true }, to: location }, renderBody())),
        !location && !onClick && (React.createElement(Container, { others: { isClickable: !!children }, onClick: children ? function () { return setIsExpanded(function (prev) { return !prev; }); } : undefined }, renderBody())),
        children && (React.createElement(ClassNames, null, function (_a) {
            var css = _a.css;
            return (React.createElement(Collapse, { isOpen: isExpanded, className: css({ transition: 'height 150ms ease-in' }) },
                React.createElement(ExpandedContainer, null, children)));
        }))));
};
//# sourceMappingURL=index.js.map