var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import React from 'react';
import styled from '../../../';
var leftChevron = "'data:image/svg+xml,%3Csvg xmlns=%22http://www.w3.org/2000/svg%22 viewBox=%220 0 86.001 86.001%22%3E%3Cpath d=%22M64.998 80.095a3.484 3.484 0 0 1 0 4.893 3.401 3.401 0 0 1-4.844 0l-39.151-39.54a3.486 3.486 0 0 1 0-4.895l39.15-39.539a3.4 3.4 0 0 1 4.844 0A3.487 3.487 0 0 1 65 5.907L29.294 43.001l35.704 37.094z%22 fill=%22%236B1FAF%22/%3E%3C/svg%3E'";
var rightChevron = "'data:image/svg+xml,%3Csvg xmlns=%22http://www.w3.org/2000/svg%22 viewBox=%220 0 512 512%22%3E%3Cpath d=%22M367.954 213.588L160.67 5.872c-7.804-7.819-20.467-7.831-28.284-.029-7.819 7.802-7.832 20.465-.03 28.284l207.299 207.731c7.798 7.798 7.798 20.486-.015 28.299L132.356 477.873c-7.802 7.819-7.789 20.482.03 28.284A19.935 19.935 0 0 0 146.513 512c5.125 0 10.25-1.958 14.157-5.873l207.269-207.701c23.394-23.394 23.394-61.459.015-84.838z%22 fill=%22%236B1FAF%22/%3E%3C/svg%3E'";
var Chevron = styled.a(function (_a) {
    var direction = _a.direction, enabled = _a.enabled, theme = _a.theme;
    return ({
        width: 20,
        height: 24,
        paddingLeft: 2,
        paddingRight: 2,
        display: 'inline-block',
        color: theme.colors.purple,
        background: "url(" + (direction === 'left' ? leftChevron : rightChevron) + ") no-repeat center center",
        backgroundSize: 12,
        opacity: enabled ? 1 : 0.3,
        cursor: enabled ? 'pointer' : 'default',
    });
});
var Ellipses = styled.span(function (_a) {
    var theme = _a.theme;
    return ({
        width: 20,
        display: 'inline-block',
        paddingLeft: 6,
        paddingRight: 6,
        textAlign: 'center',
        fontSize: 18,
        color: theme.colors.darkGray,
    });
});
var Page = styled.a(function (_a) {
    var active = _a.active, theme = _a.theme;
    return ({
        paddingLeft: 6,
        paddingRight: 6,
        width: 20,
        display: 'inline-block',
        textAlign: 'center',
        cursor: 'pointer',
        color: active ? theme.colors.black : theme.colors.purple,
        fontWeight: active ? 700 : 400,
    });
});
var PaginatorContainer = styled.div({
    userSelect: 'none',
    display: 'flex',
    fontSize: 18,
});
var Paginator = /** @class */ (function (_super) {
    __extends(Paginator, _super);
    function Paginator() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.lastPage = function () { return Math.ceil(_this.props.numberOfItems / _this.props.pageSize); };
        _this.center = function () { return Math.floor(_this.props.numbersInMiddle / 2); };
        _this.nextPage = function () {
            var nextPage = _this.props.activePage + 1;
            return nextPage <= _this.lastPage() ? nextPage : _this.props.activePage;
        };
        _this.previousPage = function () {
            var previousPage = _this.props.activePage - 1;
            return previousPage >= 1 ? previousPage : _this.props.activePage;
        };
        _this.handleClick = function (activePage) {
            _this.props.onChange(activePage);
        };
        _this.renderJumpToStart = function () {
            return (React.createElement(React.Fragment, null,
                React.createElement(Page, { onClick: function () { return _this.handleClick(1); }, key: 'start', active: false }, "1"),
                React.createElement(Ellipses, null, "\u2026"),
                " "));
        };
        _this.renderJumpToEnd = function () {
            return (React.createElement(React.Fragment, null,
                React.createElement(Ellipses, null, "\u2026"),
                React.createElement(Page, { onClick: function () { return _this.handleClick(_this.lastPage()); }, key: 'end', active: false }, _this.lastPage())));
        };
        _this.getPages = function () {
            return Array(_this.props.numbersInMiddle)
                .fill(undefined)
                .map(_this.isWithinInitialRange() ? _this.fillStart : _this.getActivePages)
                .filter(function (page) { return page !== undefined; })
                .sort(function (a, b) { return a - b; });
        };
        _this.fillStart = function (_, index) {
            return _this.props.numbersInMiddle - index <= _this.lastPage() ? _this.props.numbersInMiddle - index : undefined;
        };
        _this.fillEnd = function (_, index) { return _this.lastPage() - index; };
        _this.getActivePages = function (_, index) {
            if (_this.props.activePage + _this.props.numbersInMiddle - _this.center() > _this.lastPage()) {
                return _this.fillEnd(_, index);
            }
            var nextNumber = _this.props.activePage - index;
            if (index > _this.center()) {
                // If we're at or past the middle
                if (_this.props.activePage + index - _this.center() <= _this.lastPage()) {
                    nextNumber = _this.props.activePage + index - _this.center();
                }
            }
            return nextNumber <= _this.lastPage() ? nextNumber : undefined;
        };
        _this.isWithinInitialRange = function () {
            return _this.props.activePage <= _this.props.numbersInMiddle - _this.center() || _this.props.numbersInMiddle >= _this.lastPage();
        };
        _this.isWithinEndRange = function () {
            return _this.props.activePage + _this.props.numbersInMiddle - _this.center() > _this.lastPage() ||
                _this.props.numbersInMiddle >= _this.lastPage();
        };
        return _this;
    }
    Paginator.prototype.render = function () {
        var _this = this;
        if (this.lastPage() === 1 || this.lastPage() === 0)
            return null;
        return (React.createElement(PaginatorContainer, null,
            React.createElement(Chevron, { direction: "left", enabled: this.props.activePage !== 1, onClick: function () { return _this.handleClick(_this.previousPage()); } }),
            !this.isWithinInitialRange() && this.renderJumpToStart(),
            this.getPages().map(function (page) { return (React.createElement(Page, { onClick: function () { return _this.handleClick(page); }, key: page, active: page === _this.props.activePage }, page)); }),
            !this.isWithinEndRange() && this.renderJumpToEnd(),
            React.createElement(Chevron, { direction: "right", enabled: this.props.activePage !== this.lastPage(), onClick: function () { return _this.handleClick(_this.nextPage()); } })));
    };
    return Paginator;
}(React.Component));
export { Paginator };
//# sourceMappingURL=index.js.map