import React from 'react';
import { storiesOf } from '@storybook/react';
import { withKnobs, number } from '@storybook/addon-knobs';
import { State, Store } from '@sambego/storybook-state';
import { Paginator } from './';
import notes from './README.md';
var components = storiesOf('Components', module);
components.addDecorator(withKnobs);
var store = new Store({
    activePage: 2,
});
components.add('Paginator', function () {
    return (React.createElement(State, { store: store },
        React.createElement(Paginator, { numberOfItems: number('Number of items', 500), numbersInMiddle: number('Numbers in middle', 5), pageSize: number('Page size', 25), activePage: store.get('activePage'), onChange: function (activePage) { return store.set({ activePage: activePage }); } })));
}, { notes: notes });
//# sourceMappingURL=story.js.map