var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import React from 'react';
import Collapse from 'react-css-collapse';
import { ClassNames } from '@emotion/core';
import uniqid from 'uniqid';
import styled from '../../../';
import { Alert } from '../Alert';
import { Label } from '../Label';
import { RadioButton } from './';
var RadioButtonGroupContainer = styled.div({
    marginBottom: '1.25em',
});
var RadioButtonList = styled.ul(function (_a) {
    var direction = _a.direction;
    return ({
        listStyleType: 'none',
        display: 'flex',
        flexDirection: direction,
        padding: 0,
        margin: 0,
    });
});
var RadioButtonContainer = styled.li(function (_a) {
    var direction = _a.direction;
    return ({
        paddingRight: direction === 'row' ? 32 : 0,
    });
});
var KidsContainer = styled.div({
    overflow: 'hidden',
    marginLeft: 34,
    maxWidth: 500 - 34,
});
var RadioButtonGroup = /** @class */ (function (_super) {
    __extends(RadioButtonGroup, _super);
    function RadioButtonGroup() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            name: uniqid(),
        };
        _this.handleChange = function (key) {
            _this.props.onChange(key);
        };
        return _this;
    }
    RadioButtonGroup.prototype.render = function () {
        var _this = this;
        var _a = this.props, label = _a.label, items = _a.items, selected = _a.selected, disabled = _a.disabled, error = _a.error, _b = _a.direction, direction = _b === void 0 ? 'column' : _b;
        return (React.createElement(ClassNames, null, function (_a) {
            var css = _a.css;
            return (React.createElement(RadioButtonGroupContainer, null,
                React.createElement(Label, null, label),
                React.createElement(RadioButtonList, { direction: direction }, items.map(function (item, i) { return (React.createElement(RadioButtonContainer, { direction: direction, key: i },
                    React.createElement(RadioButton, { label: item.label, name: _this.state.name, selected: item.key === selected, disabled: disabled, onChange: function () { return _this.handleChange(item.key); } }),
                    React.createElement(Collapse, { isOpen: item.key === selected, className: css({ transition: 'height 150ms' }) },
                        React.createElement(KidsContainer, { "aria-hidden": item.key !== selected }, item.child)))); })),
                error && typeof error === 'string' && React.createElement(Alert, { type: "error", message: error, alertSize: "small" })));
        }));
    };
    RadioButtonGroup.displayName = 'Collector.RadioButtonGroup';
    return RadioButtonGroup;
}(React.Component));
export { RadioButtonGroup };
//# sourceMappingURL=RadioButtonGroup.js.map