var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import styled from '../../../';
import uniqid from 'uniqid';
var RadioButtonContainer = styled.div(function (_a) {
    var disabled = _a.disabled;
    return ({
        display: 'flex',
        marginBottom: 8,
        opacity: disabled ? 0.5 : 1,
    });
});
var Input = styled.input(function (_a) {
    var theme = _a.theme;
    return ({
        appearance: 'none',
        position: 'relative',
        background: 'none',
        border: '1px solid currentColor',
        width: 20,
        height: 20,
        flexShrink: 0,
        borderRadius: '100%',
        marginRight: '1em',
        transition: 'border-color 150ms',
        '&:after': {
            content: '""',
            position: 'absolute',
            top: 3,
            bottom: 3,
            left: 3,
            right: 3,
            borderRadius: '100%',
            transition: 'background-color 150ms',
        },
        '&:checked': {
            borderColor: theme.colors.purple,
        },
        '&:checked:after': {
            backgroundColor: theme.colors.purple,
        },
        '&:disabled': {
            borderColor: theme.colors.darkGray,
            backgroundColor: theme.colors.lightGray,
        },
        '&:disabled:checked:after': {
            backgroundColor: theme.colors.darkGray,
        },
    });
});
var RadioButton = /** @class */ (function (_super) {
    __extends(RadioButton, _super);
    function RadioButton() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            id: uniqid(),
        };
        return _this;
    }
    RadioButton.prototype.render = function () {
        var _a = this.props, label = _a.label, name = _a.name, selected = _a.selected, disabled = _a.disabled, onChange = _a.onChange, rest = __rest(_a, ["label", "name", "selected", "disabled", "onChange"]);
        return (React.createElement(RadioButtonContainer, __assign({ disabled: disabled }, rest),
            React.createElement(Input, { type: "radio", id: this.state.id, name: name, checked: selected, disabled: disabled, onChange: onChange }),
            typeof label === 'string' ? (React.createElement("label", { htmlFor: this.state.id, dangerouslySetInnerHTML: { __html: label } })) : (React.createElement("label", null, label))));
    };
    RadioButton.displayName = 'Collector.RadioButton';
    return RadioButton;
}(React.Component));
export { RadioButton };
//# sourceMappingURL=index.js.map