import React from 'react';
import { storiesOf } from '@storybook/react';
import { withKnobs, text, boolean } from '@storybook/addon-knobs';
import { State, Store } from '@sambego/storybook-state';
import { RadioButton } from './';
import { RadioButtonGroup } from './RadioButtonGroup';
import notes from './README.md';
import groupReadme from './GroupREADME.md';
import { Text } from '../../typography';
var components = storiesOf('Components', module);
components.addDecorator(withKnobs);
var state = new Store({
    selected: false,
});
components.add('Radio button', function () {
    return (React.createElement(State, { store: state },
        React.createElement(RadioButton, { label: text('Label', 'En label'), disabled: boolean('Disabled', false), selected: state.get('selected'), onChange: function () { return state.set({ selected: !state.get('selected') }); } })));
}, { notes: notes });
var groupStore = new Store({
    selected: 'foo',
});
components.add('Radio button group', function () {
    var items = [
        {
            key: 'foo',
            label: 'Alternativ 1',
        },
        {
            key: 'bar',
            label: (React.createElement("div", { style: { display: 'block' } },
                React.createElement(Text, { style: { marginBottom: -2, fontWeight: 700 } }, "Alternativ 2"),
                React.createElement(Text, { style: { marginBottom: 0 } }, "H\u00E4r \u00E4r ett syskon-element, som alltid syns.")))
        },
        {
            key: 'baz',
            label: 'Alternativ 3',
            child: React.createElement("div", null, "H\u00E4r \u00E4r ett barn-element, som bara syns om \"Alternativ 3\" \u00E4r markerat"),
        },
    ];
    return (React.createElement(State, { store: groupStore },
        React.createElement(RadioButtonGroup, { label: text('Label', 'En label'), items: items, disabled: boolean('Disabled', false), direction: boolean('Display items in row', false) ? 'row' : undefined, error: text('Error', ''), selected: groupStore.get('selected'), onChange: function (selected) { return groupStore.set({ selected: selected }); } })));
}, { groupReadme: groupReadme });
//# sourceMappingURL=story.js.map