var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
import React from 'react';
import uniqid from 'uniqid';
import { Alert } from '../Alert';
import { Label } from '../Label';
import styled from '../../../';
var arrow = "'data:image/svg+xml,%3Csvg xmlns=%22http://www.w3.org/2000/svg%22 viewBox=%220 0 16 16%22%3E%3Cpath d=%22M8 11.841a.5.5 0 0 1-.348-.141L.735 5.018a.5.5 0 0 1 .695-.719L8 10.646l6.569-6.347a.5.5 0 1 1 .695.719L8.348 11.7a.5.5 0 0 1-.348.141z%22 fill=%22%23111%22/%3E%3C/svg%3E'";
var SelectContainer = styled.div({
    marginBottom: '1.25em',
});
var SelectFieldContainer = styled.div(function (_a) {
    var hasError = _a.hasError, disabled = _a.disabled, theme = _a.theme;
    return ({
        position: 'relative',
        maxWidth: 220,
        border: '1px solid',
        backgroundColor: theme.colors.white,
        borderRadius: theme.borderRadius.small,
        borderColor: hasError ? theme.colors.red : disabled ? theme.colors.lightGray : theme.colors.mediumGray,
        '&:after': {
            content: '""',
            position: 'absolute',
            top: 0,
            right: 0,
            pointerEvents: 'none',
            background: "url(" + arrow + ") no-repeat center",
            backgroundSize: 16,
            width: 40,
            height: '100%',
        },
    });
});
var SelectField = styled.select(function (_a) {
    var theme = _a.theme;
    return ({
        font: 'inherit',
        color: 'inherit',
        appearance: 'none',
        background: 'transparent',
        border: 0,
        width: '100%',
        padding: '7px 11px',
        paddingRight: 40,
        '&::-ms-expand': {
            display: 'none',
        },
        '&:disabled': {
            background: theme.colors.offWhite,
        },
    });
});
export var Select = function (_a) {
    var label = _a.label, disabled = _a.disabled, value = _a.value, name = _a.name, error = _a.error, placeholder = _a.placeholder, onChange = _a.onChange, items = _a.items, rest = __rest(_a, ["label", "disabled", "value", "name", "error", "placeholder", "onChange", "items"]);
    var id = uniqid();
    if (!value && items) {
        items = __spreadArrays([
            {
                key: '-1',
                label: placeholder ? placeholder : '',
            }
        ], items);
    }
    return (React.createElement(SelectContainer, __assign({}, rest),
        React.createElement(Label, { htmlFor: id }, label),
        React.createElement(SelectFieldContainer, { hasError: Boolean(error), disabled: disabled },
            React.createElement(SelectField, { id: id, disabled: disabled, name: name, value: value ? value : '-1', onChange: onChange }, items ? (items.map(function (item) { return (React.createElement("option", { key: item.key ? item.key : item.label, value: item.key ? item.key : item.label, disabled: item.key === '-1' }, item.label)); })) : (React.createElement("option", { disabled: true })))),
        error && typeof error === 'string' && React.createElement(Alert, { type: "error", message: error, alertSize: "small" })));
};
//# sourceMappingURL=index.js.map