import React from 'react';
import { storiesOf } from '@storybook/react';
import { State, Store } from '@sambego/storybook-state';
import { withKnobs, text, boolean } from '@storybook/addon-knobs';
import { Select } from './';
import notes from './README.md';
var components = storiesOf('Components', module);
components.addDecorator(withKnobs);
var store = new Store({
    value: '',
});
components.add('Select', function () {
    var items = [{ label: 'Foo' }, { label: 'Bar' }, { label: 'Baz' }];
    return (React.createElement(State, { store: store },
        React.createElement(Select, { label: text('Label', 'En label'), disabled: boolean('Disabled', false), items: items, error: text('Error', ''), placeholder: text('Placeholder', ''), value: store.get('value'), onChange: function (event) { return store.set({ value: event.currentTarget.value }); } })));
}, { notes: notes });
//# sourceMappingURL=story.js.map