var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import styled from '../../../';
var track = function (theme, percentFilled) { return ({
    width: '100%',
    height: 9,
    cursor: 'pointer',
    background: percentFilled != null
        ? "linear-gradient(to right, " + theme.colors.purple + " " + percentFilled + "%, " + theme.colors.purple + " " + percentFilled + "%, " + theme.colors.lightGray + " " + percentFilled + "%)"
        : theme.colors.lightGray,
    borderRadius: theme.borderRadius.small,
}); };
var thumb = function (theme) { return ({
    boxSizing: 'border-box',
    border: '4px solid #fff',
    width: 36,
    height: 36,
    borderRadius: '100%',
    background: theme.colors.purple,
    cursor: 'pointer',
    WebkitAppearance: 'none',
    marginTop: -14,
}); };
var percentFilled = function (value, min, max) { return ((value - min) / (max - min)) * 100; };
export var Slider = styled.input(function (_a) {
    var min = _a.min, max = _a.max, value = _a.value, theme = _a.theme;
    return ({
        WebkitAppearance: 'none',
        width: '100%',
        height: 36,
        margin: 0,
        '&:focus': {
            outline: 'none',
        },
        '&::-webkit-slider-runnable-track': track(theme, percentFilled(value, min, max)),
        '&::-webkit-slider-thumb': thumb(theme),
        '&::-moz-range-track': track(theme, percentFilled(value, min, max)),
        '&::-moz-range-thumb': thumb(theme),
        '&::-ms-track': __assign(__assign({}, track(theme, percentFilled(value, min, max))), { background: 'transparent', borderColor: 'transparent', color: 'transparent' }),
        '&::-ms-fill-lower': {
            background: theme.colors.purple,
        },
        '&::-ms-fill-upper': {
            background: theme.colors.lightGray,
        },
        '&::-ms-thumb': __assign(__assign({}, thumb(theme)), { marginTop: 0 }),
    });
});
Slider.displayName = 'Collector.Slider';
//# sourceMappingURL=index.js.map