import React from 'react';
import { storiesOf } from '@storybook/react';
import { withKnobs, number } from '@storybook/addon-knobs';
import { State, Store } from '@sambego/storybook-state';
import { Slider } from './';
import notes from './README.md';
var components = storiesOf('Components', module);
components.addDecorator(withKnobs);
var store = new Store({
    value: 500,
});
components.add('Slider', function () {
    return (React.createElement("div", { style: { maxWidth: 500 } },
        React.createElement(State, { store: store },
            React.createElement(Slider, { type: "range", min: number('Min', 100), max: number('Max', 1000), value: store.get('value'), onChange: function (event) { return store.set({ value: Number(event.currentTarget.value) }); } }))));
}, { notes: notes });
//# sourceMappingURL=story.js.map