var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import { keyframes } from '@emotion/core';
import { withTheme } from 'emotion-theming';
import styled from '../../../';
var animation = keyframes({
    '0%': {
        strokeDashoffset: '0',
        strokeDasharray: '150 100',
    },
    '50%': {
        strokeDasharray: '1 250',
    },
    '100%': {
        strokeDashoffset: '502',
        strokeDasharray: '150 100',
    },
});
var AnimatedCircle = styled.circle({
    animation: animation + " 2s linear infinite",
    fill: 'none',
});
export var SpinnerSvg = function (_a) {
    var color = _a.color, size = _a.size;
    return (React.createElement("svg", { width: size, height: size, viewBox: "0 0 100 100" },
        React.createElement(AnimatedCircle, { cx: 50, cy: 50, r: 40 }),
        React.createElement(AnimatedCircle, { cx: 50, cy: 50, r: 40, stroke: color, strokeWidth: 6, strokeLinecap: "round" })));
};
var fadeIn = keyframes({
    '0%': { opacity: 0 },
    '100%': { opacity: 1 },
});
var Container = styled.div(function (_a) {
    var size = _a.size, centered = _a.centered;
    var styles = {
        display: 'inline-block',
        animation: fadeIn + " 250ms ease-in-out",
        width: size,
        height: size,
    };
    if (centered) {
        styles.position = 'absolute';
        styles.top = "calc(50% - " + size / 2 + "px)";
        styles.left = "calc(50% - " + size / 2 + "px)";
    }
    return styles;
});
var Spinner_ = function (_a) {
    var theme = _a.theme, _b = _a.size, size = _b === void 0 ? 80 : _b, _c = _a.centered, centered = _c === void 0 ? false : _c, rest = __rest(_a, ["theme", "size", "centered"]);
    return (React.createElement(Container, __assign({ size: size, centered: centered }, rest),
        React.createElement(SpinnerSvg, { size: size, color: theme.colors.purple })));
};
export var Spinner = withTheme(Spinner_);
Spinner.displayName = 'Collector.Spinner';
//# sourceMappingURL=index.js.map