import React from 'react';
import { CrossIcon } from './Icons/Cross';
import styled from '../../../';
var TagContainer = styled.div(function (_a) {
    var theme = _a.theme;
    return ({
        padding: '8px 16px',
        marginRight: 8,
        marginTop: 16,
        display: 'flex',
        alignItems: 'center',
        justifyContent: 'center',
        whiteSpace: 'nowrap',
        overflow: 'hidden',
        borderRadius: theme.borderRadius.large,
        backgroundColor: theme.colors.lightGray,
    });
});
var IconContainer = styled.div({
    marginLeft: 8,
    display: 'flex',
    '&:hover': {
        cursor: 'pointer',
    },
});
var handleKeyDown = function (event, onDelete, tag) {
    if (event.key === 'Enter' || event.key === 'Delete' || event.key === 'Backspace') {
        onDelete(tag.id);
    }
};
export var Tag = function (_a) {
    var tag = _a.tag, onDelete = _a.onDelete;
    return (React.createElement(TagContainer, null,
        tag.label,
        React.createElement(IconContainer, { role: "button", onKeyDown: function (evt) { return handleKeyDown(evt, onDelete, tag); }, onClick: function () { return onDelete(tag.id); } },
            React.createElement(CrossIcon, null))));
};
//# sourceMappingURL=Tag.js.map