import React from 'react';
import { Theme } from '../../../themes';
import { Tag } from './Tag';
export interface TagInputProps {
    tags: Tag[];
    autocompleteItems?: string[] | AutocompleteItem[];
    placeholder?: string;
    label?: string | React.ReactNode;
    canAddAllAutocompleteItemsButton?: boolean;
    addAllAutocompleteItemsButtonText?: string;
    clearAllAutocompleteItemsButtonText?: string;
    tagsDirection?: FlexDirections;
    onChange: (items: Tag[]) => void;
}
export interface AutocompleteItem {
    label: string;
    searchTerms: string[];
}
export interface TagInputState {
    value: string;
    suggestions: string[];
    id: string;
}
export declare type FlexDirections = 'row' | 'column';
export declare class TagsInput_ extends React.Component<TagInputProps & {
    theme: Theme;
}, TagInputState> {
    theme: {
        suggestionsContainerOpen: string;
        suggestionsList: string;
        suggestion: string;
        suggestionHighlighted: string;
    };
    state: TagInputState;
    private handleDelete;
    private handleChange;
    private getSuggestions;
    private getSuggestionValue;
    private renderSuggestion;
    private onSuggestionsFetchRequested;
    private onSuggestionsClearRequested;
    private renderInputComponent;
    private onSuggestionSelected;
    private isStringArray;
    private isAutocompleteArray;
    private renderTag;
    private handleKeyDown;
    private getItems;
    private addAllAutocompleteItems;
    private handleClear;
    private getStringArraySuggestions;
    private getAutocompleteItemSuggestions;
    render(): JSX.Element;
}
export declare const TagsInput: React.SFC<import("emotion-theming/types/helper").AddOptionalTo<TagInputProps & React.RefAttributes<React.Component<TagInputProps, any, any>>, "theme">>;
