var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from 'react';
import Autosuggest from 'react-autosuggest';
import { withTheme } from 'emotion-theming';
import uniqid from 'uniqid';
import { css } from 'glamor';
import styled from '../../../';
import { Button, ButtonGroup, Input, Label } from '../../../common/components';
import { Text } from '../../../common/typography';
import { Tag } from './Tag';
var suggestionsContainerOpen = function (theme) {
    return css({
        position: 'absolute',
        background: theme.colors.white,
        display: 'block',
        maxWidth: 500,
        boxSizing: 'border-box',
        border: '1px solid',
        borderRadius: theme.borderRadius.small,
        borderColor: theme.colors.mediumGray,
        zIndex: 10,
        marginTop: -4,
        width: '100%',
        boxShadow: '0 2px 6px 0 #BAAFC4',
        maxHeight: '70vh',
        overflow: 'scroll',
    });
};
var suggestionsList = function (theme) {
    return css({
        listStyle: 'none',
        padding: 0,
    });
};
var suggestionCSS = function (theme) {
    return css({
        display: 'flex',
        justifyContent: 'space-between',
        alignItems: 'center',
        transition: 'background-color 150ms',
        paddingTop: 12,
        paddingBottom: 12,
        paddingLeft: 24,
        paddingRight: 24,
        whiteSpace: 'no-wrap',
        '&:hover': {
            background: theme.colors.offWhite,
            cursor: 'pointer',
        },
    });
};
var suggestionHighlighted = function (theme) {
    return css({
        background: theme.colors.offWhite,
    });
};
var TagsContainer = styled.div(function (_a) {
    var tagsItemsDirection = _a.tagsItemsDirection;
    return ({
        display: 'inline-flex',
        marginBottom: 24,
        flexWrap: 'wrap',
        minHeight: 56,
        flexDirection: tagsItemsDirection,
    });
});
var TagsInput_ = /** @class */ (function (_super) {
    __extends(TagsInput_, _super);
    function TagsInput_() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.theme = {
            suggestionsContainerOpen: "" + suggestionsContainerOpen(_this.props.theme),
            suggestionsList: "" + suggestionsList(_this.props.theme),
            suggestion: "" + suggestionCSS(_this.props.theme),
            suggestionHighlighted: "" + suggestionHighlighted(_this.props.theme),
        };
        _this.state = {
            id: uniqid(),
            value: '',
            suggestions: [],
        };
        _this.handleDelete = function (id) {
            _this.props.onChange(_this.props.tags.filter(function (tag) { return tag.id !== id; }));
        };
        _this.handleChange = function (evt, _a) {
            var newValue = _a.newValue;
            _this.setState({
                value: newValue,
            });
        };
        _this.getSuggestions = function (value) {
            if (!_this.props.autocompleteItems) {
                return [];
            }
            var inputValue = value.trim().toLowerCase();
            var inputLength = inputValue.length;
            return _this.isStringArray(_this.props.autocompleteItems)
                ? _this.getStringArraySuggestions(inputLength, inputValue)
                : _this.getAutocompleteItemSuggestions(inputLength, inputValue);
        };
        _this.getSuggestionValue = function (suggestion) { return suggestion; };
        _this.renderSuggestion = function (suggestion) { return React.createElement(Text, { style: { marginBottom: 0 } }, suggestion); };
        _this.onSuggestionsFetchRequested = function (_a) {
            var value = _a.value;
            _this.setState({
                suggestions: _this.getSuggestions(value),
            });
        };
        _this.onSuggestionsClearRequested = function () {
            _this.setState({
                suggestions: [],
            });
        };
        _this.renderInputComponent = function (inputProps) { return React.createElement(Input, __assign({}, inputProps)); };
        _this.onSuggestionSelected = function (event, _a) {
            var suggestion = _a.suggestion;
            if (suggestion == null || suggestion.length === 0) {
                return;
            }
            _this.props.onChange(_this.props.tags.concat({ label: suggestion, id: uniqid() }));
            _this.setState({
                value: '',
            });
        };
        _this.isStringArray = function (arg) { return typeof arg[0] === 'string'; };
        _this.isAutocompleteArray = function (arg) { return typeof arg[0] === 'object'; };
        _this.renderTag = function (tag) { return React.createElement(Tag, { key: tag.id, tag: tag, onDelete: _this.handleDelete }); };
        _this.handleKeyDown = function (event) {
            if (event.key === 'Enter') {
                if (!_this.state.suggestions.some(function (suggestion) { return _this.state.value !== suggestion; })) {
                    _this.onSuggestionSelected(null, { suggestion: _this.state.value });
                }
            }
        };
        _this.getItems = function () {
            if (_this.isStringArray(_this.props.autocompleteItems)) {
                return _this.props.autocompleteItems;
            }
            else {
                if (_this.isAutocompleteArray(_this.props.autocompleteItems)) {
                    return _this.props.autocompleteItems.map(function (item) { return item.label; });
                }
            }
            return [];
        };
        _this.addAllAutocompleteItems = function () {
            var tags = _this.getItems().map(function (suggestion, index) { return ({ label: suggestion, id: index.toString() }); });
            _this.props.onChange(tags);
        };
        _this.handleClear = function () {
            _this.setState({ value: '' }, function () { return _this.props.onChange([]); });
        };
        return _this;
    }
    TagsInput_.prototype.getStringArraySuggestions = function (inputLength, inputValue) {
        var _this = this;
        if (this.isStringArray(this.props.autocompleteItems)) {
            return this.props.autocompleteItems
                .filter(function (item) { return !_this.props.tags.some(function (tag) { return tag.label === item; }); })
                .filter(function (item) { return item.toLowerCase().slice(0, inputLength) === inputValue; });
        }
        return [];
    };
    TagsInput_.prototype.getAutocompleteItemSuggestions = function (inputLength, inputValue) {
        var _this = this;
        if (this.isAutocompleteArray(this.props.autocompleteItems)) {
            return this.props.autocompleteItems
                .filter(function (item) { return !_this.props.tags.some(function (tag) { return item.label === tag.label; }); })
                .filter(function (item) { return item.searchTerms.some(function (term) { return term.toLowerCase().slice(0, inputLength) === inputValue; }); })
                .map(function (autoCompleteItem) { return autoCompleteItem.label; });
        }
        return [];
    };
    TagsInput_.prototype.render = function () {
        var _a = this.state, value = _a.value, id = _a.id, suggestions = _a.suggestions;
        var _b = this.props, placeholder = _b.placeholder, tags = _b.tags, canAddAllAutocompleteItemsButton = _b.canAddAllAutocompleteItemsButton, addAllAutocompleteItemsButtonText = _b.addAllAutocompleteItemsButtonText, clearAllAutocompleteItemsButtonText = _b.clearAllAutocompleteItemsButtonText, label = _b.label, tagsDirection = _b.tagsDirection;
        var inputProps = {
            placeholder: placeholder,
            value: value,
            onChange: this.handleChange,
            onKeyDown: this.handleKeyDown,
            id: id,
        };
        return (React.createElement(React.Fragment, null,
            label && React.createElement(Label, { htmlFor: id }, label),
            React.createElement(Autosuggest, { suggestions: suggestions, getSuggestionValue: this.getSuggestionValue, onSuggestionSelected: this.onSuggestionSelected, renderSuggestion: this.renderSuggestion, onSuggestionsClearRequested: this.onSuggestionsClearRequested, onSuggestionsFetchRequested: this.onSuggestionsFetchRequested, inputProps: inputProps, focusInputOnSuggestionClick: false, renderInputComponent: this.renderInputComponent, highlightFirstSuggestion: true, theme: this.theme }),
            canAddAllAutocompleteItemsButton && (React.createElement(ButtonGroup, null,
                React.createElement(Button, { onClick: this.addAllAutocompleteItems, size: "small", kind: "secondary" }, addAllAutocompleteItemsButtonText),
                React.createElement(Button, { size: "small", kind: "warn", onClick: this.handleClear }, clearAllAutocompleteItemsButtonText))),
            tags && tags.length > 0 && (React.createElement(TagsContainer, { tagsItemsDirection: tagsDirection ? tagsDirection : 'row' }, tags.map(this.renderTag)))));
    };
    return TagsInput_;
}(React.Component));
export { TagsInput_ };
export var TagsInput = withTheme(TagsInput_);
//# sourceMappingURL=index.js.map