var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import styled from '../../../';
var Outer = styled.div(function (_a) {
    var _b;
    var theme = _a.theme, visible = _a.visible;
    return (_b = {
            position: 'absolute',
            zIndex: 20,
            left: -5,
            top: 'calc(100% + 8px)',
            width: 320,
            transitionDuration: '200ms',
            transitionProperty: 'opacity, visibility, transform',
            visibility: visible ? 'visible' : 'hidden',
            opacity: visible ? 1 : 0,
            transform: visible ? 'translateY(0)' : 'translateY(-5px)',
            // the arrow
            '&:before': {
                content: '""',
                borderLeft: '5px solid transparent',
                borderRight: '5px solid transparent',
                position: 'absolute',
                left: 10,
                top: -5,
                borderBottom: "5px solid " + theme.colors.lightGray,
            }
        },
        _b[theme.breakpoints.mobileAndLower] = {
            top: 'auto',
            left: 8,
            right: 8,
            width: 'auto',
            '&:before': {
                display: 'none',
            },
        },
        _b);
});
var Inner = styled.div(function (_a) {
    var theme = _a.theme;
    return ({
        display: 'inline-block',
        padding: '4px 8px',
        background: theme.colors.lightGray,
        color: theme.colors.black,
        borderRadius: theme.borderRadius.small,
        font: theme.fonts.desktop.small,
        fontWeight: 500,
        whiteSpace: 'pre-line',
    });
});
export var Tooltip = function (_a) {
    var visible = _a.visible, children = _a.children, rest = __rest(_a, ["visible", "children"]);
    return (React.createElement(Outer, __assign({ visible: visible }, rest),
        React.createElement(Inner, null, children)));
};
Tooltip.displayName = 'Collector.Tooltip';
//# sourceMappingURL=index.js.map