var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import styled from '../..';
import { darken } from 'polished';
var actionButtonsBreakpoint = '@media only screen and (max-width: 1024px)';
var Button = styled.button(function (_a) {
    var _b;
    var theme = _a.theme;
    return (_b = {
            display: 'flex',
            alignItems: 'center',
            justifyContent: 'center',
            color: theme.colors.purple,
            border: 'none',
            background: 'none',
            cursor: 'pointer'
        },
        _b[actionButtonsBreakpoint] = {
            flexDirection: 'column',
            width: '33%',
        },
        _b['> div'] = {
            transition: 'border-color 150ms ease-in',
            border: '2px solid transparent',
        },
        _b['&:focus'] = {
            outline: 'none',
            '> div': {
                borderColor: theme.colors.purple,
            },
        },
        _b['&:hover'] = {
            div: {
                background: darken(0.02, theme.colors.lavender),
            },
        },
        _b['&:active'] = {
            div: {
                background: darken(0.04, theme.colors.lavender),
            },
        },
        _b);
});
var IconSquare = styled.div(function (_a) {
    var _b;
    var theme = _a.theme;
    return (_b = {
            color: theme.colors.purple,
            background: theme.colors.lavender,
            borderRadius: 16,
            padding: 10,
            display: 'flex',
            alignItems: 'center',
            justifyContent: 'center'
        },
        _b[theme.breakpoints.mobileAndLower] = {
            padding: 14,
        },
        _b);
});
var LabelContainer = styled.span(function (_a) {
    var _b;
    var theme = _a.theme;
    return (_b = {
            font: theme.fonts.desktop.medium,
            fontWeight: 300,
            lineHeight: 1.25,
            marginLeft: 12
        },
        _b[actionButtonsBreakpoint] = {
            font: theme.fonts.mobile.small,
            lineHeight: 1.25,
            fontWeight: 300,
            margin: 0,
            marginTop: 8,
        },
        _b);
});
var IconContainer = styled.div({
    width: 16,
    height: 16,
});
export var ActionButton = function (_a) {
    var icon = _a.icon, label = _a.label, rest = __rest(_a, ["icon", "label"]);
    return (React.createElement(Button, __assign({}, rest),
        React.createElement(IconSquare, null,
            React.createElement(IconContainer, null, icon)),
        React.createElement(LabelContainer, null, label)));
};
//# sourceMappingURL=index.js.map