import * as React from 'react';
/**
 * @param data This is a render-prop which you use to only render your content when data has come into effect
 * @param setDependencyList This is a callback which you use to set the list of dependencies for the useEffect hook.
 * Using this will allow you to re-fetch the data if you have a dependency on a submit for example.
 */
declare type Child<TResult> = (data: TResult, setDependencyList: (dependencies: any) => void) => React.ReactNode;
interface Props<TResult> {
    apiMethod: (abortSignal?: AbortSignal) => Promise<TResult>;
    children: Child<TResult>;
    errorText: string;
    errorIndicator?: React.ReactNode;
    notFoundIndicator?: React.ReactNode;
    loadingIndicator?: React.ReactNode;
}
export declare const FetchHandler: <TResult extends {}>({ apiMethod, children, errorText, errorIndicator, notFoundIndicator, loadingIndicator, }: Props<TResult>) => JSX.Element;
export {};
