import * as React from 'react';
import { useEffect, useState } from 'react';
import { usePromise } from '../hooks';
import { Spinner, Alert } from '.';
export var FetchHandler = function (_a) {
    var apiMethod = _a.apiMethod, children = _a.children, errorText = _a.errorText, errorIndicator = _a.errorIndicator, notFoundIndicator = _a.notFoundIndicator, loadingIndicator = _a.loadingIndicator;
    var _b = usePromise(apiMethod), loading = _b.loading, data = _b.data, error = _b.error, trigger = _b.trigger;
    var _c = useState(undefined), dependencyList = _c[0], setDependencyList = _c[1];
    useEffect(function () {
        trigger();
    }, [trigger, dependencyList]);
    var renderError = function () {
        if (errorIndicator && (error === null || error === void 0 ? void 0 : error.code) !== 404 && notFoundIndicator) {
            return errorIndicator;
        }
        else if ((error === null || error === void 0 ? void 0 : error.code) === 404 && notFoundIndicator) {
            return notFoundIndicator;
        }
        return (error === null || error === void 0 ? void 0 : error.code) !== 401 ? React.createElement(Alert, { type: "error", message: errorText }) : React.createElement(Spinner, { centered: true });
    };
    return (React.createElement(React.Fragment, null,
        loading && (loadingIndicator ? loadingIndicator : React.createElement(Spinner, { centered: true })),
        error && renderError(),
        data && children(data, function (dependencies) { return setDependencyList(dependencies); })));
};
//# sourceMappingURL=FetchHandler.js.map