var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from 'react';
import ReactModal from 'react-modal';
import { Global, ClassNames } from '@emotion/core';
import { borderRadius, colors, breakpoints } from '../../themes/collector';
var rootElement = document.getElementById('root');
if (rootElement) {
    ReactModal.setAppElement(rootElement);
}
var transitionTime = 300;
export var Modal = function (props) { return (React.createElement(React.Fragment, null,
    React.createElement(Global, { styles: {
            '.ReactModal__Body--open': {
                overflow: 'hidden',
                touchAction: 'none',
            },
        } }),
    React.createElement(ClassNames, null, function (_a) {
        var _b;
        var css = _a.css;
        return (React.createElement(ReactModal, __assign({}, props, { closeTimeoutMS: transitionTime + 50, shouldCloseOnOverlayClick: true, ariaHideApp: rootElement == null ? false : undefined, className: {
                base: css((_b = {
                        background: colors.white,
                        boxShadow: '0 2px 7px 0 rgba(0, 0, 0, 0.2)',
                        outline: 'none',
                        overflow: 'auto',
                        WebkitOverflowScrolling: 'touch',
                        padding: '40px',
                        borderRadius: borderRadius.small,
                        boxSizing: 'border-box',
                        maxHeight: 'calc(100vh - 11px)',
                        maxWidth: 'calc(100vw - 16px)',
                        marginTop: 8,
                        transition: "transform " + transitionTime + "ms ease-out",
                        transform: 'translateY(-30px)'
                    },
                    _b[breakpoints.mobileAndLower] = {
                        padding: 24,
                    },
                    _b)),
                afterOpen: css({
                    transform: 'translateY(0)',
                }),
                beforeClose: css({
                    transition: "transform " + transitionTime + "ms ease-in",
                    transform: 'translateY(-30px)',
                }),
            }, overlayClassName: {
                base: css({
                    position: 'fixed',
                    top: 0,
                    bottom: 0,
                    left: 0,
                    right: 0,
                    background: 'rgba(0, 0, 0, .3)',
                    display: 'flex',
                    justifyContent: 'center',
                    alignItems: 'center',
                    zIndex: 999,
                    transition: "opacity " + transitionTime + "ms ease-in-out",
                    opacity: 0,
                }),
                afterOpen: css({
                    'body &': {
                        opacity: 1,
                    },
                }),
                beforeClose: css({
                    'body &': {
                        opacity: 0,
                    },
                }),
            } }), props.children));
    }))); };
//# sourceMappingURL=index.js.map