import React from 'react';
import { Theme } from '../../themes';
import { AddOptionalTo } from 'emotion-theming/types/helper';
export interface MainMenuProps {
    items: MainMenuItem[];
    menuFooter?: JSX.Element;
    menuEvents?: MenuEvents;
}
export interface NavLinkIconProps {
    icon: string;
}
export interface MainMenuItem {
    path: string;
    label: string;
    icon: string;
    externalLink?: boolean;
    useMarginTop?: boolean;
    onClick?: (item: MainMenuItem) => void;
}
export interface MenuEvents {
    onOpen?: () => void;
    onClose?: () => void;
}
export declare const MainMenu: React.FC<AddOptionalTo<MainMenuProps, Theme>>;
