import React, { useRef } from 'react';
import { NavLink } from 'react-router-dom';
import styled from '../..';
var Container = styled.nav({
    marginBottom: 30,
});
var InnerContainer = styled.div(function (_a) {
    var _b;
    var theme = _a.theme;
    return (_b = {
            display: 'block'
        },
        _b[theme.breakpoints.tabletAndLower] = {
            maxWidth: 500,
        },
        _b);
});
var List = styled.ul(function (_a) {
    var _b;
    var theme = _a.theme;
    return (_b = {
            listStyleType: 'none',
            padding: 0,
            margin: 0,
            display: 'flex',
            borderBottom: 0
        },
        _b[theme.breakpoints.tabletAndLower] = {
            flexDirection: 'column',
            borderRadius: theme.borderRadius.small,
            border: "1px solid " + theme.colors.lightGray,
            borderBottom: 'none',
        },
        _b);
});
var Link = styled(NavLink)(function (_a) {
    var _b;
    var theme = _a.theme;
    return (_b = {
            display: 'block',
            padding: '12px 20px',
            textDecoration: 'none',
            fontSize: 18,
            fontWeight: 500,
            minWidth: 100,
            transitionProperty: 'border-color, color',
            transitionDuration: '200ms',
            textAlign: 'center',
            borderBottom: "4px solid " + theme.colors.lightGray,
            '&:hover': {
                color: theme.colors.purple,
            },
            color: 'inherit',
            '&.active': {
                color: theme.colors.purple,
                borderColor: theme.colors.purple,
            }
        },
        _b[theme.breakpoints.tabletAndLower] = {
            textAlign: 'left',
            borderBottom: "1px solid " + theme.colors.lightGray,
            borderLeft: "4px solid " + theme.colors.lightGray,
            flexDirection: 'column',
            paddingLeft: 16,
            '&.active': {
                borderBottom: "1px solid " + theme.colors.lightGray,
                borderLeftColor: theme.colors.purple,
            },
        },
        _b);
});
var VerticalList = styled.ul(function (_a) {
    var theme = _a.theme;
    return ({
        listStyleType: 'none',
        padding: 0,
        margin: 0,
        display: 'flex',
        flexDirection: 'column',
        borderRadius: theme.borderRadius.small,
        border: "1px solid " + theme.colors.lightGray,
        borderBottom: 'none',
        maxWidth: 500,
    });
});
var VerticalLink = styled(NavLink)(function (_a) {
    var theme = _a.theme;
    return ({
        display: 'block',
        padding: '12px 20px',
        textDecoration: 'none',
        fontSize: 18,
        fontWeight: 500,
        minWidth: 100,
        transitionProperty: 'border-color, color',
        transitionDuration: '200ms',
        '&:hover': {
            color: theme.colors.purple,
        },
        color: 'inherit',
        '&.active': {
            borderBottom: "1px solid " + theme.colors.lightGray,
            borderLeftColor: theme.colors.purple,
        },
        textAlign: 'left',
        borderBottom: "1px solid " + theme.colors.lightGray,
        borderLeft: "4px solid " + theme.colors.lightGray,
        flexDirection: 'column',
        paddingLeft: 16,
    });
});
export var Tabs = function (_a) {
    var items = _a.items, isVertical = _a.isVertical;
    var ref = useRef(null);
    if (isVertical) {
        return (React.createElement(Container, null,
            React.createElement(InnerContainer, { ref: ref },
                React.createElement(VerticalList, null, items.map(function (item, i) { return (React.createElement("li", { key: i },
                    React.createElement(VerticalLink, { exact: true, to: item.path }, item.label))); })))));
    }
    return (React.createElement(Container, null,
        React.createElement(InnerContainer, { ref: ref },
            React.createElement(List, null, items.map(function (item, i) { return (React.createElement("li", { key: i },
                React.createElement(Link, { exact: true, to: item.path }, item.label))); })))));
};
//# sourceMappingURL=index.js.map