import React, { useState } from 'react';
import Collapse from 'react-css-collapse';
import { ClassNames } from '@emotion/core';
import uniqid from 'uniqid';
import { H2, H3 } from '../../components';
import styled from '../../';
var expandIcon = require('./expand.svg');
var collapseIcon = require('./collapse.svg');
var Container = styled.div({
    padding: '16px 0',
    maxWidth: 900,
});
var Header = styled.div({
    display: 'flex',
    alignItems: 'center',
    cursor: 'pointer',
    '> h2, > h3': {
        margin: 0,
    },
});
var ToggleButton = styled.button(function (_a) {
    var expanded = _a.expanded, iconSize = _a.iconSize;
    return ({
        fontFamily: 'inherit',
        cursor: 'pointer',
        backgroundColor: 'transparent',
        border: 0,
        marginRight: 12,
        backgroundRepeat: 'no-repeat',
        backgroundImage: expanded ? "url(" + collapseIcon + ")" : "url(" + expandIcon + ")",
        width: iconSize === 'medium' ? 24 : 21,
        height: iconSize === 'medium' ? 24 : 21,
        backgroundSize: iconSize === 'medium' ? undefined : 18,
    });
});
export var Togglable = function (_a) {
    var defaultExpanded = _a.defaultExpanded, size = _a.size, title = _a.title, children = _a.children, onClick = _a.onClick;
    var _b = useState(!!defaultExpanded), isExpanded = _b[0], setIsExpanded = _b[1];
    var id = uniqid();
    var toggleSize = size ? size : 'medium';
    var toggle = function () {
        setIsExpanded(function (prevExpanded) { return !prevExpanded; });
        if (onClick) {
            onClick(isExpanded);
        }
    };
    return (React.createElement(ClassNames, null, function (_a) {
        var css = _a.css;
        return (React.createElement(Container, null,
            React.createElement(Header, { onClick: toggle, "aria-expanded": isExpanded, "aria-controls": id },
                React.createElement(ToggleButton, { expanded: isExpanded, iconSize: toggleSize }),
                toggleSize === 'medium' ? React.createElement(H2, null, title) : React.createElement(H3, null, title)),
            React.createElement(Collapse, { isOpen: isExpanded, className: css({ transition: 'height 150ms' }) },
                React.createElement("div", { id: id }, children))));
    }));
};
//# sourceMappingURL=index.js.map