import React from 'react';
import { storiesOf } from '@storybook/react';
import { withKnobs } from '@storybook/addon-knobs';
import { PortalHeader } from './PortalHeader';
import { BrowserRouter } from 'react-router-dom';
import { PortalContainer, PortalMain, PageHeader, PageContainer } from '.';
var components = storiesOf('Portal Components', module);
components.addDecorator(withKnobs);
components.add('Portal Example', function () {
    return (React.createElement(BrowserRouter, null,
        React.createElement(PortalContainer, { backLinkText: "Tillbaka till \u00F6versikten", backLink: "http:://aftonbladet.se" },
            React.createElement(PortalHeader, { logoTarget: "aftonbladet.se", siteName: "Storybook", menuItems: [{ icon: 'haus', path: '/', label: 'Storybook', onClick: function (item) { console.log('click: ' + item.label); } }], menuEvents: { onOpen: function () { return console.log('open menu'); }, onClose: function () { return console.log('close menu'); } } }),
            React.createElement(PortalMain, null,
                React.createElement(PageHeader, { title: "Test" }),
                React.createElement(PageContainer, null,
                    React.createElement("div", { style: { height: 1200 } }, "Content!"))))));
});
//# sourceMappingURL=story.js.map