import React from 'react';
var getIconBy = function (type) {
    switch (type) {
        case 'cui-is-success':
            return 'cui-icon-check';
        case 'cui-is-info':
            return 'cui-icon-info';
        case 'cui-is-warning':
            return 'cui-icon-warning';
        case 'cui-is-danger':
            return 'cui-icon-danger';
        default:
            return 'cui-icon-check';
    }
};
export var Notification = function (_a) {
    var type = _a.type, title = _a.title, description = _a.description, _b = _a.hasIcon, hasIcon = _b === void 0 ? true : _b, _c = _a.isOutlined, isOutlined = _c === void 0 ? false : _c, linkHref = _a.linkHref, linkText = _a.linkText, onClose = _a.onClose;
    return (React.createElement(React.Fragment, null,
        React.createElement("div", { className: "cui-notification " + type + " " + (isOutlined ? 'cui-is-outlined' : '') },
            hasIcon && (React.createElement("div", { className: "cui-notification-left" },
                React.createElement("figure", { className: getIconBy(type) + " cui-is-large" }))),
            React.createElement("div", { className: "cui-notification-content" },
                title && React.createElement("div", { className: 'cui-title' }, title),
                typeof description === 'string' ? React.createElement("p", null, description) : description),
            linkHref && linkText && (React.createElement("div", { className: "cui-notification-right" },
                React.createElement("a", { href: linkHref, className: "cui-is-link" }, linkText))),
            onClose && (React.createElement("div", { className: "cui-notification-close" },
                React.createElement("a", { className: "cui-closable", onClick: onClose },
                    React.createElement("figure", { className: "cui-icon-close cui-is-normal" })))))));
};
//# sourceMappingURL=index.js.map