var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
import * as React from 'react';
import { useEffect, useState } from 'react';
import styled from '@emotion/styled';
import { PortalAsideMenuItem } from './PortalAsideMenuItem';
import { PortalAsideDropdown } from './PortalAsideDropdown';
import { getTraversedMenuNodes } from './portalMenu';
import { useHistory } from 'react-router-dom';
var FootContent = styled.section({
    height: 'auto',
    margin: '20px 0px',
});
export var PortalAsideMenu = function (_a) {
    var menuTree = _a.menuTree, menuFooter = _a.menuFooter, _b = _a.nrOfUnreadMessages, nrOfUnreadMessages = _b === void 0 ? 0 : _b, _c = _a.isNavMenuOpen, isNavMenuOpen = _c === void 0 ? true : _c, toggleHamburgerClick = _a.toggleHamburgerClick;
    var _d = useState([]), traversedMenu = _d[0], setTraversedMenu = _d[1];
    var _e = useState(''), activeMenuItemUrl = _e[0], setActiveMenuItemUrl = _e[1];
    var _f = useState([]), menuItems = _f[0], setMenuItems = _f[1];
    var history = useHistory();
    useEffect(function () {
        var menuItems = __spreadArrays(menuTree.asidePortalItems, menuTree.asideGeneralItems);
        setMenuItems(menuItems);
        var pathname = getCurrentRoutePathBy(menuItems);
        var traversedMenuNodes = getTraversedMenuNodes(menuItems, pathname, false, setActiveMenuItemUrl);
        setTraversedMenu(traversedMenuNodes);
    }, [menuTree]);
    useEffect(function () {
        return history.listen(function () {
            var pathname = getCurrentRoutePathBy(menuItems);
            var traversedMenuNodes = getTraversedMenuNodes(menuItems, pathname, false, setActiveMenuItemUrl);
            if (traversedMenuNodes.length > 0) {
                setTraversedMenu(traversedMenuNodes);
            }
        });
    }, [menuItems]);
    var getCurrentRoutePathBy = function (menuItems) {
        var pathname = window.location.pathname;
        var menuItemPathname = '';
        var submenuItemFound = null;
        menuItems.forEach(function (menuItem) {
            if (menuItem.subpages.length === 0) {
                submenuItemFound = pathname.indexOf(menuItem.url) !== (-1 || 0) ? menuItem : null;
            }
            else {
                submenuItemFound = menuItem.subpages.find(function (submenuItem) {
                    return pathname.indexOf(submenuItem.url) !== (-1 || 0);
                });
            }
            if (submenuItemFound) {
                menuItemPathname = submenuItemFound.url;
            }
        });
        return menuItemPathname;
    };
    var isDropdownActive = function (menuLevel, indexNode) {
        if (traversedMenu[menuLevel]) {
            return traversedMenu[menuLevel].index === indexNode;
        }
        return false;
    };
    var isMenuItemActive = function (menuItem) {
        return activeMenuItemUrl === menuItem.url;
    };
    var getNextUrlOf = function (subpages, index) {
        if (index === void 0) { index = 0; }
        var menuItem = subpages[index];
        return menuItem.url === '' ? getNextUrlOf(subpages, ++index) : menuItem.url;
    };
    var closeDropdown = function (traversedMenuItemIndex) {
        var traverseBack = traversedMenu.slice(0, traversedMenuItemIndex);
        setTraversedMenu(traverseBack);
    };
    var openDropdown = function (selectedDropdownMenuItem) {
        var url = getNextUrlOf(selectedDropdownMenuItem.subpages);
        var traversedMenuNodes = getTraversedMenuNodes(menuItems, url, true);
        setTraversedMenu(traversedMenuNodes);
    };
    var onClickDropdown = function (selectedDropdownMenuItem) {
        var id = selectedDropdownMenuItem.id;
        var traversedMenuItemIndex = traversedMenu.findIndex(function (traversedMenuItem) { return id === traversedMenuItem.id; });
        traversedMenuItemIndex !== -1 ? closeDropdown(traversedMenuItemIndex)
            : openDropdown(selectedDropdownMenuItem);
    };
    var onClickNavItem = function (url) {
        var traversedMenuNodes = getTraversedMenuNodes(menuItems, url, false, setActiveMenuItemUrl);
        setTraversedMenu(traversedMenuNodes);
        toggleHamburgerClick();
    };
    var Menu = function (menu) {
        return createSubmenuFrom(menu.asidePortalItems)
            .concat(React.createElement("div", { className: "cui-nav-divider", key: '0-divider' }))
            .concat(createSubmenuFrom(menu.asideGeneralItems));
    };
    var createSubmenuFrom = function (menuItems, menuLevel, isDropdown) {
        if (menuLevel === void 0) { menuLevel = 0; }
        if (isDropdown === void 0) { isDropdown = false; }
        return isDropdown ? (React.createElement("div", { className: "cui-nav-subgroup" }, getMenuItemsOf(menuItems, menuLevel))) : (getMenuItemsOf(menuItems, menuLevel));
    };
    var getMenuItemsOf = function (menuItems, menuLevel) {
        return menuItems.map(function (menuItem, index) {
            var isDropdown = menuItem.subpages.length > 0;
            var nextMenuLevel = menuLevel + 1;
            return (React.createElement(React.Fragment, { key: menuItem.label + index },
                getMenuItem(menuItem, index, menuLevel, isDropdown),
                isDropdown && createSubmenuFrom(menuItem.subpages, nextMenuLevel, isDropdown)));
        });
    };
    var getMenuItem = function (menuItem, indexNode, menuLevel, isDropdown) {
        if (isDropdown) {
            return (React.createElement(PortalAsideDropdown, { menuItem: menuItem, isActive: isDropdownActive(menuLevel, indexNode), onClick: onClickDropdown }));
        }
        else {
            return (React.createElement(PortalAsideMenuItem, { menuItem: menuItem, isActive: isMenuItemActive(menuItem), onClick: onClickNavItem, nrOfUnreadMessages: nrOfUnreadMessages }));
        }
    };
    return (React.createElement("aside", { className: "cui-left-nav " + (isNavMenuOpen ? 'cui-is-open' : '') },
        menuTree && menuTree.asidePortalItems.length > 0 && Menu(menuTree),
        menuFooter ? (React.createElement("span", { onClick: function () { return toggleHamburgerClick(); } },
            React.createElement(FootContent, null, menuFooter))) : ''));
};
//# sourceMappingURL=PortalAsideMenu.js.map