import * as React from 'react';
import { Link } from 'react-router-dom';
import { getIconBy } from './portalIcons';
export var getIcon = function (icon) {
    return icon ? (React.createElement("span", { className: "cui-img" }, getIconBy(icon))) : '';
};
export var PortalAsideMenuItem = function (_a) {
    var isActive = _a.isActive, menuItem = _a.menuItem, onClick = _a.onClick, _b = _a.nrOfUnreadMessages, nrOfUnreadMessages = _b === void 0 ? 0 : _b;
    var onClickMenuItem = function (url) {
        onClick(url);
    };
    var getMenuItemContent = function (menuItem) {
        return (React.createElement(React.Fragment, null,
            getIcon(menuItem.icon),
            React.createElement("div", { className: "cui-content" },
                menuItem.label,
                menuItem.hasOwnProperty('isMsg')
                    && menuItem.isMsg
                    && nrOfUnreadMessages > 0
                    ? React.createElement("span", { className: "cui-msg" }, nrOfUnreadMessages)
                    : '')));
    };
    var getMenuItem = function () {
        if (menuItem.hasExternalUrl) {
            return (React.createElement("a", { className: "cui-nav-item", href: menuItem.url }, getMenuItemContent(menuItem)));
        }
        else {
            return (React.createElement(Link, { className: "cui-nav-item " + (isActive ? 'cui-is-active' : ''), to: menuItem.url, onClick: function () { return onClickMenuItem(menuItem.url); } }, getMenuItemContent(menuItem)));
        }
    };
    return (getMenuItem());
};
//# sourceMappingURL=PortalAsideMenuItem.js.map