import React, { useEffect, useState } from 'react';
import { svg } from './portalIcons';
import { PortalAsideMenu } from './PortalAsideMenu';
import { createMenuTreeBy } from './portalMenu';
import { PortalTopMenu } from './PortalTopMenu';
import styled from '../../../';
var Overlay = styled.section({
    zIndex: 1,
    position: 'fixed',
    width: '100vw',
    height: '100vh'
});
var portalMenuInit = {
    homeUrl: '',
    topItems: [],
    asideGeneralItems: [],
    asidePortalItems: [],
};
export var Portal = function (_a) {
    var portalMenu = _a.portalMenu, children = _a.children, menuFooter = _a.menuFooter, _b = _a.nrOfUnreadMessages, nrOfUnreadMessages = _b === void 0 ? 0 : _b;
    var _c = useState(portalMenuInit), menuTree = _c[0], setMenuTree = _c[1];
    var _d = useState(false), isHamburgerMenuOpen = _d[0], setIsHamburgerMenuOpen = _d[1];
    useEffect(function () {
        var hostname = window.location.hostname;
        var clonedMenu = JSON.parse(JSON.stringify(portalMenu));
        var menuTree = createMenuTreeBy(clonedMenu, hostname);
        setMenuTree(menuTree);
    }, [portalMenu]);
    useEffect(function () {
        var smallDeviceBreakpoint = 768;
        if (window.innerWidth < smallDeviceBreakpoint) {
            isHamburgerMenuOpen ? document.body.style.overflow = 'hidden' : document.body.style.overflow = 'visible';
        }
    }, [isHamburgerMenuOpen]);
    var toggleHamburgerClick = function () {
        setIsHamburgerMenuOpen(function (prevHamburgerMenuOpen) { return !prevHamburgerMenuOpen; });
    };
    return (React.createElement(React.Fragment, null,
        React.createElement("nav", { className: "cui-top-nav" },
            React.createElement("button", { className: 'cui-menu-btn', onClick: toggleHamburgerClick },
                React.createElement("div", { className: "cui-menu-btn-bar " + (isHamburgerMenuOpen ? 'cui-is-open' : '') }),
                React.createElement("div", { className: "cui-menu-btn-bar " + (isHamburgerMenuOpen ? 'cui-is-open' : '') }),
                React.createElement("div", { className: "cui-menu-btn-bar " + (isHamburgerMenuOpen ? 'cui-is-open' : '') }),
                React.createElement("div", { className: "cui-menu-btn-bar " + (isHamburgerMenuOpen ? 'cui-is-open' : '') })),
            React.createElement("figure", { className: "cui-logo" }, menuTree && menuTree.homeUrl ? React.createElement("a", { href: menuTree.homeUrl }, svg.collectorLogo) : React.createElement(React.Fragment, null, svg.collectorLogo)),
            menuTree && menuTree.topItems
                ? React.createElement(PortalTopMenu, { submenu: menuTree.topItems, nrOfUnreadMessages: nrOfUnreadMessages })
                : ''),
        React.createElement("section", { className: "cui-middle-content" },
            menuTree ? React.createElement(PortalAsideMenu, { menuTree: menuTree, isNavMenuOpen: isHamburgerMenuOpen, menuFooter: menuFooter, toggleHamburgerClick: toggleHamburgerClick, nrOfUnreadMessages: nrOfUnreadMessages })
                : '',
            React.createElement("section", { className: "cui-site-content" }, children),
            isHamburgerMenuOpen && (React.createElement(Overlay, { onClick: toggleHamburgerClick })))));
};
//# sourceMappingURL=index.js.map