import dateFormatter from 'date-fns/format';
import parseISO from 'date-fns/parseISO';
Number.isInteger =
    Number.isInteger ||
        function (value) {
            return typeof value === 'number' && isFinite(value) && Math.floor(value) === value;
        };
export var formatDate = function (date, format) {
    if (format === void 0) { format = 'yyyy-MM-dd'; }
    if (date) {
        if (typeof date === 'string') {
            date = parseISO(date);
        }
        return dateFormatter(date, format);
    }
    return '';
};
export var formatMoney = function (money, currency, includeDecimals) {
    if (includeDecimals === void 0) { includeDecimals = true; }
    if (money != null) {
        var formatted = money
            .toFixed(includeDecimals && !Number.isInteger(money) ? 2 : 0)
            .replace(/\B(?=(\d{3})+(?!\d))/g, ' ')
            .replace('.', ',');
        return currency ? formatted + " " + currency : formatted;
    }
    return '';
};
export var formatPercentage = function (fraction) {
    if (fraction != null) {
        return (fraction * 100).toFixed(2).replace('.', ',') + ' %';
    }
    return '';
};
export var formatString = function (str) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        args[_i - 1] = arguments[_i];
    }
    if (args.length > 0) {
        return str.replace(/{(\d+)}/g, function (match, i) { return (args[i] == null ? match : args[i]); });
    }
    return str;
};
//# sourceMappingURL=formatters.js.map