import { useState, useEffect } from 'react';
var getSize = function () { return ({
    innerHeight: window.innerHeight,
    innerWidth: window.innerWidth,
    outerHeight: window.outerHeight,
    outerWidth: window.outerWidth,
}); };
export var useWindowSize = function () {
    var _a = useState(getSize()), windowSize = _a[0], setWindowSize = _a[1];
    function handleResize() {
        setWindowSize(getSize());
    }
    useEffect(function () {
        window.addEventListener('resize', handleResize);
        return function () {
            window.removeEventListener('resize', handleResize);
        };
    }, []);
    return windowSize;
};
//# sourceMappingURL=use-window-size.js.map