var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var getCookie = function (key) {
    var matches = document.cookie.match('(^|;)\\s*' + key + '\\s*=\\s*([^;]+)');
    return matches ? matches.pop() : null;
};
var request = function (method, returnRawResponse) {
    if (returnRawResponse === void 0) { returnRawResponse = false; }
    return function (endpoint, payload, extraHeaders, abortSignal) { return __awaiter(void 0, void 0, void 0, function () {
        var headers, csrfToken, csrfTokenPrevious, options, getPromiseForStatus, getJsonOrText, response, error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    headers = new Headers({
                        'X-Requested-With': 'XMLHttpRequest',
                        Accept: 'application/json',
                    });
                    if (!(payload instanceof FormData)) {
                        headers.append('Content-Type', 'application/json');
                    }
                    csrfToken = getCookie('__Host-CSRF-TOKEN');
                    if (csrfToken) {
                        headers.append('X-CSRF-Token', csrfToken);
                    }
                    csrfTokenPrevious = getCookie('CSRF-TOKEN');
                    if (!csrfToken && csrfTokenPrevious) {
                        headers.append('X-CSRF-Token', csrfTokenPrevious);
                    }
                    if (extraHeaders) {
                        Object.keys(extraHeaders).forEach(function (key) { return headers.append(key, extraHeaders[key]); });
                    }
                    options = {
                        headers: headers,
                        method: method,
                        credentials: 'same-origin',
                        signal: abortSignal,
                    };
                    if (payload) {
                        options.body = payload instanceof FormData ? payload : JSON.stringify(payload);
                    }
                    getPromiseForStatus = function (response, stream) {
                        return stream.then(function (content) {
                            return response.status >= 200 && response.status < 300 ? content : Promise.reject({ status: response.status, content: content });
                        });
                    };
                    getJsonOrText = function (response) {
                        return response.headers.has('Content-Type') && response.headers.get('Content-Type').indexOf('application/json') !== -1
                            ? response.json()
                            : response.text();
                    };
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 4, , 5]);
                    return [4 /*yield*/, window.fetch(endpoint, options)];
                case 2:
                    response = _a.sent();
                    return [4 /*yield*/, getPromiseForStatus(response, returnRawResponse ? Promise.resolve(response) : getJsonOrText(response))];
                case 3: return [2 /*return*/, _a.sent()];
                case 4:
                    error_1 = _a.sent();
                    if (error_1.name === 'AbortError') {
                        console.log('The user aborted a request.');
                        return [2 /*return*/];
                    }
                    console.error(error_1);
                    throw error_1;
                case 5: return [2 /*return*/];
            }
        });
    }); };
};
export var get = request('GET');
export var post = request('POST');
export var put = request('PUT');
export var del = request('DELETE');
export var patch = request('PATCH');
export var getRaw = request('GET', true);
export var download = function (response, fallbackFileName) {
    if (fallbackFileName === void 0) { fallbackFileName = 'file'; }
    return __awaiter(void 0, void 0, void 0, function () {
        var file, _a, _b, filename, disposition, matches, a;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    _b = (_a = window.URL).createObjectURL;
                    return [4 /*yield*/, response.blob()];
                case 1:
                    file = _b.apply(_a, [_c.sent()]);
                    filename = fallbackFileName;
                    if (response.headers.has('Content-Disposition')) {
                        disposition = response.headers.get('Content-Disposition');
                        matches = /filename[^;=\n]*=((['"]).*?\2|[^;\n]*)/.exec(disposition);
                        if (matches != null && matches[1]) {
                            filename = matches[1].replace(/['"]/g, '');
                        }
                    }
                    a = document.createElement('a');
                    a.href = file;
                    a.download = filename;
                    a.style.display = 'none';
                    document.body.appendChild(a);
                    a.click();
                    setTimeout(function () { return document.body.removeChild(a); }, 100);
                    return [2 /*return*/];
            }
        });
    });
};
//# sourceMappingURL=http.js.map